/*
For the work of indicator should be placed the file
JJMASeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
/*
//------------------------------------------------------------------
//| 3c_.SG_.Osc.mqh |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
# property copyright "Nikolay Kositsin"
# property link "farria@mail.redcom.ru"
/ otrisovka of indicator in the separate window
# property indicator_.separate_.window
/ a quantity of the indicator buffers
# property indicator_.buffers 5
/ the color of the indicator
# property indicator_.color1 BlueViolet
# property indicator_.color2 Blue
# property indicator_.color3 Magenta
# property indicator_.color4 Gray
# property indicator_.color5 Red
/ the thickness of the indicator lines
# property indicator_.width1 0
# property indicator_.width2 3
# property indicator_.width3 3
# property indicator_.width4 4
/ the style of the envelope of the indicator
# property indicator_.style1 4
/ the style of the signal line of the indicator
# property indicator_.style5 4
/ the parameters of the horizontal levels of the indicator
# property indicator_.level1 0.0
# property indicator_.levelcolor Red
# property indicator_.levelstyle 4
*/
// THE INPUT PARAMETERS OF THE INDICATOR OF---------------------------------------------------------------------
extern int Signal_.Length = 15; //the depth of the smoothing of thesignal line
extern int Signal_.Phase = 100; //the parameter of signal line, whichis changed within limits of -100... 100, influence the quality oftransient process;
extern int Ind_.Shift = 0; //cdvig indicator along the time axis
//-------------------------------------------------------------------------------------------------
// the indicator buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[];
double Ind_Buffer4[];
double Ind_Buffer5[];
// the entire variables
int bar;
// variables with the floating point
double trend,Signal,Out_Series;
//------------------------------------------------------------------
// introduction to function JJMASeries
// introduction to function JJMASeriesResize
// introduction to function JJMASeriesAlert
// introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//| JMACD initialization function
//------------------------------------------------------------------
int init()
  {
// the styles of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(4,DRAW_LINE);
// 4 indicator buffers are used for the calculation
if(!SetIndexBuffer(0,Ind_Buffer1)&& 
   !SetIndexBuffer(1,Ind_Buffer2)&& 
   !SetIndexBuffer(2,Ind_Buffer3)&& 
   !SetIndexBuffer(3,Ind_Buffer4)&& 
   !SetIndexBuffer(4,Ind_Buffer5))
   Print("cannot set indicator buffers!");
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,EmptyValue);
   SetIndexEmptyValue(1,EmptyValue);
   SetIndexEmptyValue(2,EmptyValue);
   SetIndexEmptyValue(3,EmptyValue);
   SetIndexEmptyValue(4,EmptyValue);
// names for the windows of data and leyby for sub"okon
   IndicatorShortName(""+Label+"");
   SetIndexLabel   (0,NULL);
   SetIndexLabel   (1,"Up_Trend");
   SetIndexLabel   (2,"Down_Trend");
   SetIndexLabel   (3,"Straight_Trend");
   SetIndexLabel   (4,"Signal");
// the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(digits());
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int draw_begin=COUNT_begin()+Ind_Shift+1;
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);
   draw_begin+=29;
   SetIndexDrawBegin(3,draw_begin);
// the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Signal_Length",Signal_Length);
JJMASeriesAlert (1,"Signal_Phase", Signal_Phase);
PriceSeriesAlert(Input_Price_Customs);
// a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);

// the completion of the initialization
   return(0);
  }
//------------------------------------------------------------------
//| JMACD iteration function |
//------------------------------------------------------------------
int start()
  {
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,limit,MaxBarS,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1-COUNT_begin()-1; MaxBarS=MaxBar+1;      
// the load of the values of initial indicator into the buffer
for(bar=limit; bar>=0; bar--)Ind_Buffer1[bar]=INDICATOR(bar);
// korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
// initialization of zero
if (limit>MaxBar)
 {
  limit=MaxBar; 
  for(int ttt=Bars-1;ttt>MaxBar;ttt--)
   {
    Ind_Buffer2[ttt]=EmptyValue; 
    Ind_Buffer3[ttt]=EmptyValue; 
    Ind_Buffer4[ttt]=EmptyValue;
    Ind_Buffer5[ttt]=EmptyValue; 
   }
 }

// the calculation of the indicator
for(bar=limit;bar>=0;bar--)
   {
    Out_Series=Ind_Buffer1[bar];
// SSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    trend=Out_Series-Ind_Buffer1[bar+1];     
    if(trend>0)     {Ind_Buffer2[bar]=Out_Series; Ind_Buffer3[bar]=EmptyValue; Ind_Buffer4[bar]=EmptyValue;}
    else{if(trend<0){Ind_Buffer2[bar]=EmptyValue; Ind_Buffer3[bar]=Out_Series; Ind_Buffer4[bar]=EmptyValue;}
    else            {Ind_Buffer2[bar]=EmptyValue; Ind_Buffer3[bar]=EmptyValue; Ind_Buffer4[bar]=Out_Series;}}    
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
     
// turning to function JJMASeries after number 0, (nJMAdin=0)
    Signal=JJMASeries(0,0,MaxBarS,limit,Signal_Phase,Signal_Length,Out_Series,bar,reset);
// checking to the absence of error in the previous operation
    if(reset!=0)return(-1);
    Ind_Buffer5[bar]=Signal;
   }
// the completion of the calculations of the values of the indicator
   return(0);
  } 
//---------------------------------------------------------------------------

