//+------------------------------------------------------------------+  
//|                                              Aroon_Oscilator.mq4 | 
//|                             Copyright ? 2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property  indicator_separate_window
//a quantity of the indicator buffers
#property  indicator_buffers 4
#property  indicator_color1  BlueViolet
#property  indicator_color2  Blue
#property  indicator_color3  Red
#property  indicator_color4  LightSlateGray
//THE INPUT PARAMETERS OF THE INDICATOR
extern int Aroon_Period=10;
extern int Filter=50;
//---- +--------------------------+
//the indicator buffers
double ind_buffer1[];
double ind_buffer2[];
double ind_buffer3[];
double ArOscBuffer[];
//+------------------------------------------------------------------+ 
//| Aroon_Oscilator initialization function                          |
//+------------------------------------------------------------------+ 
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
//the parameters of the horizontal levels of the indicator
   SetLevelStyle(4,0,Gold);
   SetLevelValue(0,0);
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,Aroon_Period+1);
   SetIndexDrawBegin(1,Aroon_Period+1);
   SetIndexDrawBegin(2,Aroon_Period+1);
   SetIndexDrawBegin(3,Aroon_Period+1);
//4 indicator buffers are used for the calculation
   if
    (
     !SetIndexBuffer(0,ArOscBuffer)&& 
     !SetIndexBuffer(1,ind_buffer1)&& 
     !SetIndexBuffer(2,ind_buffer2)&& 
     !SetIndexBuffer(3,ind_buffer3)
    )
    {
Print("Nevozmojno to establish indicator buffers!");
     return(0);
    }
//names for the windows of data and leyby for sub"okon
   IndicatorShortName("Aroon Osc(Aroon_Period="+Aroon_Period+", Filter="+Filter+")");
   SetIndexLabel(0,"Aroon Osc");
   SetIndexLabel(1,"UP_Trend");
   SetIndexLabel(2,"DOWN_Trend");
   SetIndexLabel(3,"Flat");
//the correction of the inadmissible value of Aroon_.Period
   if(Aroon_Period<1) Aroon_Period=1;
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//| Aroon_Oscilator iteration function                               |
//+------------------------------------------------------------------+ 
int start()
  {
   int MaxBar=Bars-Aroon_Period-1;
//checking a quantity of bars to the sufficiency for the calculation
   if (MaxBar<0)return(0);
//the introduction of variables with the floating point
   double ArOsc;
//the introduction of entire variables and obtaining the alreadycalculated bars
   int limit,bar,highest,lowest,counted_bars=IndicatorCounted();  
//checking to the possible errors
   if (counted_bars<0)return(-1);
//the last calculated bar must be converted
   if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
   limit=Bars-counted_bars-1; 
//initialization of zero
   if(limit>MaxBar)
     {
      limit=MaxBar;
      for(bar=Bars-1;bar>=MaxBar;bar--) 
       {
        ArOscBuffer[bar]=0.0;
        ind_buffer1[bar]=0.0;
        ind_buffer2[bar]=0.0;
        ind_buffer3[bar]=0.0;
       }
     } 
//THE CALCULATION OF THE INDICATOR
   for( bar=limit; bar>=0; bar--)
   {
  	   highest = Highest(NULL,0,MODE_HIGH,Aroon_Period,bar);  
  	   lowest  = Lowest (NULL,0,MODE_LOW, Aroon_Period,bar);	
      //----
  	   ArOscBuffer[bar]= 100*(lowest-highest)/Aroon_Period;		
      //----
      ind_buffer1[bar]=0.0;
      ind_buffer2[bar]=0.0;
      ind_buffer3[bar]=0.0;
      //----    
      ArOsc=ArOscBuffer[bar];
      //----
      if(ArOsc> Filter)ind_buffer1[bar]=ArOsc; else
      if(ArOsc<-Filter)ind_buffer2[bar]=ArOsc; else
      ind_buffer3[bar]=ArOsc; 
   }
   //---- done
   return(0);
  }
//+------------------------------------------------------------+ 
