/*
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
*/
//+------------------------------------------------------------------+
//|                                              Bollinger Bands.mq4 | 
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of indicator bufferov
#property indicator_buffers 3
//the color of the indicator
#property indicator_color1 Blue
#property indicator_color2 Lime
#property indicator_color3 Blue
//the style of lines Bollinger Bands
#property indicator_style1 4
#property indicator_style2 4
#property indicator_style3 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Bands_.Period = 20; //the period of averaging J2BollingerBands
extern double Bands_.Deviations = 2.0; //deviatatsiya
extern int MA_.method = 0; //the method of the averaging
extern int Bands_.Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//---- buffers
double UpperBuffer[];
double LowerBuffer[];
double MovingBuffer[];
double SeriesBuffer[];
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| Bollinger Bands initialization function                          | 
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE); 
   SetIndexStyle(1,DRAW_LINE);
//4 indicator bufferov are used for the calculation
   IndicatorBuffers(4); 
   SetIndexBuffer(0,UpperBuffer );  
   SetIndexBuffer(1,MovingBuffer);
   SetIndexBuffer(2,LowerBuffer );
   SetIndexBuffer(3,SeriesBuffer);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int drawbegin=Bands_Period+Bands_Shift; 
   SetIndexDrawBegin(0,drawbegin);
   SetIndexDrawBegin(1,drawbegin);
   SetIndexDrawBegin(2,drawbegin);
//the horizontal shift of the indicator lines
   SetIndexShift (0, Bands_Shift); 
   SetIndexShift (1, Bands_Shift); 
   SetIndexShift (2, Bands_Shift); 
//name for the windows of data and leyba for sub"okon.
   IndicatorShortName ("Bollinger Bands( Period="+Bands_Period+", Deviations="+Bands_Deviations+")"); 
   SetIndexLabel (0, "Upper Bands"); 
   SetIndexLabel (2, "Lower Bands"); 
   switch(MA_method)
           {
            case  0: SetIndexLabel (1, "JMoving Avereges JSMA ("+Bands_Period+")");break;
            case  1: SetIndexLabel (1, "JMoving Avereges JEMA ("+Bands_Period+")");break;
            case  2: SetIndexLabel (1, "JMoving Avereges JSSMA("+Bands_Period+")");break;
            case  3: SetIndexLabel (1, "JMoving Avereges JLWMA("+Bands_Period+")");break;
            default: SetIndexLabel (1, "JMoving Avereges JSMA ("+Bands_Period+")");
           }
//----          
//the installation of Alerts at the inadmissible values of the inputparameters of======================================================================================
if(.Bands_.Period
if(.MA_.method
if(.MA_.method 3) {Alert("Parametr MA_.method must be from 0 to 3""you they introduced that not admitted" MA_.method "will be used0");}////////////////|
PriceSeriesAlert(Input_Price_Customs);//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////|
//+========================================================================================================================================================+ 
//korektsiya of the inadmissible value of parameter Bands_.Period
if(Bands_Period<1)Bands_Period=1; 
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands iteration function                               | 
//+------------------------------------------------------------------+
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
if(Bars<=Bands_Period) return(0);
//the introduction of variables with the floating point
double sum,midline,priceswing,deviation;
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,kk,MaxBarBB,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBarBB=Bars-1-Bands_Period;
//the load of input prices into buffer for the calculation
for(bar=limit;bar>=0;bar--)SeriesBuffer[bar]=PriceSeries(Input_Price_Customs,bar);
//checking bar to the sufficiency for calculation Bollinger Bands
if (limit>MaxBarBB)limit=MaxBarBB;

for(bar=limit;bar>=0;bar--)
     {
//formula for calculation Moving Avereges
      midline=iMAOnArray(SeriesBuffer,0,Bands_Period,0,MA_method, bar);
      MovingBuffer[bar]=midline;
      
//CALCULATION Bollinger Bands
      sum=0.0;
      kk=bar+Bands_Period-1;
      while(kk>=bar)
        {
         priceswing=PriceSeries(Input_Price_Customs,kk)-midline;
         sum+=priceswing*priceswing;
         kk--;
        }
      deviation=Bands_Deviations*MathSqrt(sum/Bands_Period);
      UpperBuffer[bar]=midline+deviation;
      LowerBuffer[bar]=midline-deviation;
      //----
    }
//----
   return(0);
  } 
//+------------------------------------------------------------------+

