/*
For the work of indicator should be placed the files
JJMASeries.mqh
and PriceSeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.indicators \
*/
//------------------------------------------------------------------
//| J2JMA_.Channel.mq4 |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 3
// the color of the indicator
#property indicator_color1 Red
#property indicator_color2 Gray
#property indicator_color3 Gray
// the style of the lines of the indicator
#property indicator_style1 0
#property indicator_style2 4
#property indicator_style3 4
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Channel_.width = 100; //the width of channel in the points
extern int Length1 = 3; //the depth of the first smoothing
extern int Phase1 = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of the transient processof the first smoothing
extern int Length2 = 3; //the depth of the second smoothing
extern int Phase2 = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of the transient processof the second smoothing
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
//yy-.Yueiken Ashi High, y2-.Yueiken Ashi Low, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.)
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double J2JMA[];
double UpperBuffer[];
double LowerBuffer[];
// constant with the floating point
double Half_Width;
//------------------------------------------------------------------
// introduction to function JJMASeries
// introduction to function JJMASeriesResize
// introduction to function JJMASeriesAlert
// introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//------------------------------------------------------------------
// introduction to function PriceSeries
// introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//------------------------------------------------------------------
//| J2JMA_.Channel initialization function |
//------------------------------------------------------------------
int init() 
{ 
// the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE);
SetIndexStyle (1,DRAW_LINE);
SetIndexStyle (2,DRAW_LINE); 
// 3 indicator buffers are used for the calculation
SetIndexBuffer(0,J2JMA);  
SetIndexBuffer(1,UpperBuffer); 
SetIndexBuffer(2,LowerBuffer);
// the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);  
SetIndexEmptyValue(1,0.0); 
SetIndexEmptyValue(2,0.0); 
// the horizontal shift of the indicator lines
SetIndexShift (0, Shift); 
SetIndexShift (1, Shift); 
SetIndexShift (2, Shift); 
// a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=2(Dva turning to function JJMASeries)
if (JJMASeriesResize(2)!=2)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Length1",Length1);
JJMASeriesAlert (0,"Length2",Length2);
JJMASeriesAlert (1,"Phase1", Phase1 );
JJMASeriesAlert (1,"Phase1", Phase1 );
JJMASeriesAlert (1,"Phase2", Phase2 );
JJMASeriesAlert (1,"Phase2", Phase2 );
PriceSeriesAlert(Input_Price_Customs);
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
int draw_begin=50; 
SetIndexDrawBegin(0,draw_begin);
SetIndexDrawBegin(1,draw_begin);
SetIndexDrawBegin(2,draw_begin); 
// the size of channel in the points
Half_Width = Channel_width*Point/2;
// the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
// the completion of the initialization
return(0); 
}
//------------------------------------------------------------------
//| J2JMA_.Channel iteration function |
//------------------------------------------------------------------
int start() 
{ 
// checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=30+30) return(0);
// the introduction of variables with the floating point
double Series,Resalt,Price,JSeries,JJSeries;
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1; int limit=MaxBar-counted_bars;

// THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(int bar=limit;bar>=0;bar--)
  {
// turning to function PriceSeries for obtaining the input priceSeries
    Price=PriceSeries(Input_Price_Customs, bar);
// turning to function JJMASeries after to numbers 0. ParametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
    JSeries=JJMASeries(0,0,MaxBar,limit,Phase1,Length1,Price,bar,reset);
// checking to the absence of error in the previous operation
    if(reset!=0)return(-1);
// turning to function JJMASeries after to numbers 1. ParametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
    JJSeries=JJMASeries(1,0,MaxBar,limit,Phase2,Length2,JSeries,bar,reset);
// checking to the absence of error in the previous operation
    if(reset!=0)return(-1);
    
    J2JMA[bar]=JJSeries;
// channel design
   UpperBuffer[bar]=JJSeries+Half_Width;     
   LowerBuffer[bar]=JJSeries-Half_Width;
// the completion of the calculations of the values of the indicator
  }
return(0); 
} 
//-------------------------------------------------------
