/*
For the work of indicator should be placed the files
JJMASeries.mqh
PriceSeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.indicators \
*/
//------------------------------------------------------------------
//| J4Bollinger Bands.mq4 |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 5
// the color of the indicator
#property indicator_color1 Red
#property indicator_color2 Blue 
#property indicator_color3 Lime
#property indicator_color4 Blue
#property indicator_color5 Red
// the style of the lines of the indicator
#property indicator_style1 4
#property indicator_style2 2
#property indicator_style3 4
#property indicator_style4 2
#property indicator_style5 4
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Bands_.Period = 100; //the period of averaging J2BollingerBands
extern double Bands_.Deviations = 2.0; //deviatatsiya
extern int MA_.method = 0; //the method of the averaging
extern int MA_.Smooth = 20; //the depth of the smoothing of thatobtained Moving Avereges
extern int Bands_.Smooth = 20; //the depth of the smoothing of thoseobtained Bollinger Bands
extern int Smooth_.Phase = 100; //the parameter of smoothing, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int Bands_.Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
//yy-.Yueiken Ashi Low, y2-.Yueiken Ashi High, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.)
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double UpperBuffer2 [];
double UpperBuffer1 [];
double JMovingBuffer[];
double LowerBuffer1 [];
double LowerBuffer2 [];
double Series_buffer[];
//------------------------------------------------------------------
// introduction to function JJMASeries
// introduction to function JJMASeriesResize
// introduction to function JJMASeriesAlert
// introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//------------------------------------------------------------------
// introduction to function PriceSeries
// introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//------------------------------------------------------------------
//| J4Bollinger Bands initialization function |
//------------------------------------------------------------------
int init()
  {
// the determination of the style of the performance of the graph
   SetIndexStyle(0,DRAW_LINE); 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE); 
   SetIndexStyle(4,DRAW_LINE);
// 4 indicator buffers are used for the calculation
   IndicatorBuffers(6);
   SetIndexBuffer(0,UpperBuffer2 );
   SetIndexBuffer(1,UpperBuffer1 );
   SetIndexBuffer(2,JMovingBuffer);
   SetIndexBuffer(3,LowerBuffer1 );
   SetIndexBuffer(4,LowerBuffer2 );
   SetIndexBuffer(5,Series_buffer);
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
   SetIndexEmptyValue(3,0);
   SetIndexEmptyValue(4,0);
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int drawbegin=Bands_Period+30+Bands_Shift;
   SetIndexDrawBegin(0,drawbegin);
   SetIndexDrawBegin(1,drawbegin);
   SetIndexDrawBegin(2,drawbegin);
   SetIndexDrawBegin(3,drawbegin);
   SetIndexDrawBegin(4,drawbegin);
// the horizontal shift of the indicator lines
   SetIndexShift (0, Bands_Shift); 
   SetIndexShift (1, Bands_Shift); 
   SetIndexShift (2, Bands_Shift); 
   SetIndexShift (3, Bands_Shift); 
   SetIndexShift (4, Bands_Shift); 
// name for the windows of data and leyba for sub"okon
   IndicatorShortName ("J4Bollinger Bands( Period="+Bands_Period+", Deviations="+Bands_Deviations+")"); 
   SetIndexLabel (0, "Upper2 Bands");
   SetIndexLabel (1, "Upper1 Bands"); 
   SetIndexLabel (3, "Lower1 Bands"); 
   SetIndexLabel (4, "Lower2 Bands"); 
   string Moving;
   switch(MA_method)
           {
            case  0: Moving= "JSMA";break;
            case  1: Moving= "JEMA";break;
            case  2: Moving="JSSMA";break;
            case  3: Moving="JLWMA";break;
            default: Moving="JSMA";
           }
   SetIndexLabel (2, "JMoving Avereges "+Moving+" ("+Bands_Period+")");
// the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
// a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=5(P4t6 turnings to function JJMASeries)
   if (Bands_Smooth<=1){if (JJMASeriesResize(1)!=1)return(-1);}else if (JJMASeriesResize(5)!=5)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"Bands_Period",Bands_Period);
   JJMASeriesAlert (0,"MA_Smooth",   MA_Smooth);
   JJMASeriesAlert (1,"Smooth_Phase", Smooth_Phase);
   PriceSeriesAlert(Input_Price_Customs);
   if((MA_method<0)||(MA_method>3))
                 Alert("???????? MA_method ?????? ???? ?? 0 ?? 3"+" ?? ????? ???????????? " 
                                                                   +MA_method+ " ????? ???????????? 0");
// korektsiya of the inadmissible value of parameter Bands_.Period
   if(Bands_Period<1)Bands_Period=1; 
// the completion of the initialization
   return(0);
  }
//------------------------------------------------------------------
//| J4Bollinger Bands iteration function |
//------------------------------------------------------------------
int start()
  {
// checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=Bands_Period) return(0);
// the introduction of variables with the floating point
double deviation1,deviation2,Temp_Series,sum,midline,priceswing,Resalt;
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,MaxBarBB,bar,kk,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
// (without this conversion for counted_.bars function JJMASeries itwill work incorrectly!!!)
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1;MaxBar=Bars-1-Bands_Period;MaxBarBB=MaxBar-30-Bands_Period;
// the load of input prices into the buffer for the calculation
for(bar=limit;bar>=0;bar--)Series_buffer[bar]=PriceSeries(Input_Price_Customs,bar);
// checking bar to the sufficiency for calculation Bollinger Bands
// initialization of zero
if (limit>MaxBar)
     {
      for(bar=limit;bar>=MaxBar;bar--)JMovingBuffer[bar]=0;
      limit=MaxBar;
     }
// the cycle of calculation Moving Avereges
for(bar=limit;bar>=0;bar--)
     {
// formula for calculation Moving Avereges
      Temp_Series=iMAOnArray(Series_buffer,0,Bands_Period,0,MA_method, bar);
// the smoothing of that obtained Moving Avereges
// turning to function JJMASeries after number 0. Parameters nJMA.Phaseand nJMA.Length do not change on each bar (nJMA.din=0)
      Resalt=JJMASeries(0,0,MaxBar,limit,Smooth_Phase,MA_Smooth,Temp_Series,bar,reset);
// checking to the absence of error in the previous operation
      if(reset!=0)return(-1); 
      JMovingBuffer[bar]=Resalt; 
     }     
// CALCULATION Bollinger Bands
// initialization of zero
if (limit>MaxBarBB)
     {
      for(bar=limit;bar>=MaxBarBB;bar--)
       {
        UpperBuffer2[bar]=0;
        UpperBuffer1[bar]=0;
        LowerBuffer1[bar]=0;
        LowerBuffer2[bar]=0;
       }
      limit=MaxBarBB;
     }
for(bar=limit;bar>=0;bar--)
   {         
     sum=0.0;
     midline=JMovingBuffer[bar];
     kk=bar+Bands_Period-1;
     while(kk>=bar)
      {
       priceswing=PriceSeries(Input_Price_Customs,kk)-midline;
       sum+=priceswing*priceswing;
       kk--;
      }
     deviation2=Bands_Deviations*MathSqrt(sum/Bands_Period);     
     deviation1=0.5*deviation2;
     if (Bands_Smooth>1)
        {
// calculation and JMA smoothing Bollinger Bands
//----------------------------------------------------------------------------------------
// four parallel turnings to function JJMASeries after numbers 1, 2, 3,4.
// parameters nJJMA.Length not menya.ttsya on each bar (nJJMA.din=0)
//----------------------------------------------------------------------------------------
         Resalt=JJMASeries(1,0,MaxBarBB-1,limit,Smooth_Phase,Bands_Smooth ,midline+deviation2,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         UpperBuffer2[bar]=Resalt; 
//----------------------------------------------------------------------------------------
         Resalt=JJMASeries(2,0,MaxBarBB-1,limit,Smooth_Phase,Bands_Smooth ,midline+deviation1,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         UpperBuffer1[bar]=Resalt; 
//----------------------------------------------------------------------------------------
         Resalt=JJMASeries(3,0,MaxBarBB-1,limit,Smooth_Phase,Bands_Smooth ,midline-deviation1,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         LowerBuffer1[bar]=Resalt; 
//----------------------------------------------------------------------------------------
         Resalt=JJMASeries(4,0,MaxBarBB-1,limit,Smooth_Phase,Bands_Smooth ,midline-deviation2,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         LowerBuffer2[bar]=Resalt;         
//----------------------------------------------------------------------------------------
        }
      else 
        {
// calculation Bollinger Bands without JMA smoothing
         UpperBuffer2[bar]=midline+deviation2;
         UpperBuffer1[bar]=midline+deviation1;
         LowerBuffer1[bar]=midline-deviation1;
         LowerBuffer2[bar]=midline-deviation2;
        }
      
   }
// the completion of the calculations of the values of the indicator
   return(0);
  }
//-----------------------------------------------------------------------------

