/*
For the work of indicator should be placed the files
JJMASeries.mqh
PriceSeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.indicators \
*/
//------------------------------------------------------------------
//| JFatls_.Channel.mq4 |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 3
// the color of the indicator
#property indicator_color1 Blue
#property indicator_color2 Magenta
#property indicator_color3 Blue
// the style of the lines of the indicator
#property indicator_style1 4
#property indicator_style2 0
#property indicator_style3 4
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Channel_.width = 100; //the width of channel in the points
extern int Length = 3; //the depth of the smoothing
extern int Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of transient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(TO 0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
yy-.Yueiken Ashi Low, y2-.Yueiken Ashi High, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.) */
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double JFilter[];
double UpperBuffer[];
double LowerBuffer[];
// the buffer of the coefficients of the digital filter
double Filter[1];
// the entire constants
int nf; 
// Constants with the floating point
double Half_Width;
//------------------------------------------------------------------
// introduction to function JJMASeries
// introduction to function JJMASeriesResize
// introduction to function JJMASeriesAlert
// introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//------------------------------------------------------------------
// introduction to function PriceSeries
// introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//------------------------------------------------------------------
//| JFatls_.Channel initialization function |
//------------------------------------------------------------------
int init() 
{ 
// the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE);
SetIndexStyle (1,DRAW_LINE);
SetIndexStyle (2,DRAW_LINE); 
// 3 indicator buffers are used for the calculation
SetIndexBuffer(0,UpperBuffer); 
SetIndexBuffer(1,JFilter);  
SetIndexBuffer(2,LowerBuffer); 
// the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);  
SetIndexEmptyValue(1,0.0); 
SetIndexEmptyValue(2,0.0); 
// a change in rezmera of buffer Filter[
nf=38;int count=ArrayResize(Filter,nf+1);if(count==0){Alert("?????????? ???????? ?????? ??? ?????? Filter");return(0);}
//=== the initialization of the coefficients of the digital filter of =======================================================================
Filter[00]=+0.4360409450;Filter[01]=+0.3658689069;Filter[02]=+0.2460452079;Filter[03]=+0.1104506886;Filter[04]=-0.0054034585;
Filter[05]=-0.0760367731;Filter[06]=-0.0933058722;Filter[07]=-0.0670110374;Filter[08]=-0.0190795053;Filter[09]=+0.0259609206;
Filter[10]=+0.0502044896;Filter[11]=+0.0477818607;Filter[12]=+0.0249252327;Filter[13]=-0.0047706151;Filter[14]=-0.0272432537;
Filter[15]=-0.0338917071;Filter[16]=-0.0244141482;Filter[17]=-0.0055774838;Filter[18]=+0.0128149838;Filter[19]=+0.0226522218; 
Filter[20]=+0.0208778257;Filter[21]=+0.0100299086;Filter[22]=-0.0036771622;Filter[23]=-0.0136744850;Filter[24]=-0.0160483392;
Filter[25]=-0.0108597376;Filter[26]=-0.0016060704;Filter[27]=+0.0069480557;Filter[28]=+0.0110573605;Filter[29]=+0.0095711419;
Filter[30]=+0.0040444064;Filter[31]=-0.0023824623;Filter[32]=-0.0067093714;Filter[33]=-0.0072003400;Filter[34]=-0.0047717710;
Filter[35]=+0.0005541115;Filter[36]=+0.0007860160;Filter[37]=+0.0130129076;Filter[38]=+0.0040364019;
//=========================================================================================================================
// a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Length",Length);
JJMASeriesAlert (1,"Phase", Phase);
PriceSeriesAlert(Input_Price_Customs);
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
int draw_begin=nf+30; 
SetIndexDrawBegin(0,draw_begin);
SetIndexDrawBegin(1,draw_begin);
SetIndexDrawBegin(2,draw_begin);
// the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits); 
// the size of channel in the points
Half_Width = Channel_width*Point/2;
// the completion of the initialization
return(0); 
}
//------------------------------------------------------------------
//| JFATL iteration function |
//------------------------------------------------------------------
int start() 
{ 
// checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=nf)return(0);
// the introduction of variables with the floating point
double FILTER,Series,Half_Width,Resalt;
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,limit,MaxBar,bar,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; 
MaxBar=Bars-1-nf;
// korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
// initialization of zero
if (limit>=MaxBar)
 {
  for(bar=limit;bar>=MaxBar;bar--)
   {
    JFilter[bar]=0.0; 
    UpperBuffer[bar]=0.0;    
    LowerBuffer[bar]=0.0; 
   }
  limit=MaxBar;
 }

// the calculation of the digital filter Fatl
for(bar=limit;bar>=0;bar--)
  {
   FILTER=0.0;
   for(int ii=0;ii<=nf;ii++)
    {
// turning to function PriceSeries for obtaining the input priceSeries
     Series=PriceSeries(Input_Price_Customs, bar+ii);
     FILTER=FILTER+Filter[ii]*Series;
    }
// JMA the smoothing of the obtained indicator, parameter nJMAMaxBar isreduced by the size of filter nf
// the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
   Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,FILTER,bar,reset);
// checking to the absence of error in the previous operation
   if(reset!=0)return(-1); 
   JFilter[bar]=Resalt; 
// channel design
   UpperBuffer[bar]=Resalt+Half_Width;     
   LowerBuffer[bar]=Resalt-Half_Width;
// the completion of the calculations of the values of the indicator
  }
return(0); 
} 
//------------------------------------------------------------------------

