/*
For the work of indicator should be placed the files
T3Series.mqh
PriceSeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.indicators \
*/
//------------------------------------------------------------------
//| T3.2Bollinger Bands.mq4 |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 3
// the color of the indicator
#property indicator_color1 Gray
#property indicator_color2 Lime
#property indicator_color3 Gray
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Bands_.Period = 100; //the period of averaging T3BollingerBands
extern double Bands_.Deviations = 2.0; //deviatatsiya
extern int MA_.method = 0; //the method of the averaging
extern int MA_.Smooth = 20; //the depth of the smoothing of thatobtained Moving Avereges
extern int Bands_.Smooth = 20; //the depth of the smoothing of thoseobtained Bollinger Bands
extern int Smooth_.Curvature = 100; //the parameter of smoothing,which is changed within limits of -100... 100, influence the qualityof transient process;
extern int Bands_.Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
//yy-.Yueiken Ashi Low, y2-.Yueiken Ashi High, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.)
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double UpperBuffer   [];
double T3MovingBuffer[];
double LowerBuffer   [];
double Series_buffer [];
//------------------------------------------------------------------
// introduction to function T3Series
// introduction to function T3SeriesResize
// introduction to function T3SeriesAlert
// introduction to function T3_.ErrDescr
#include <T3Series.mqh> 
//------------------------------------------------------------------
// introduction to function PriceSeries
// introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//------------------------------------------------------------------
//| T3.2Bollinger Bands initialization function |
//------------------------------------------------------------------
int init()
  {
// the determination of the style of the performance of the graph
   SetIndexStyle(0,DRAW_LINE); 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
// 4 indicator buffers are used for the calculation
   IndicatorBuffers(4);
   SetIndexBuffer(0,UpperBuffer  );
   SetIndexBuffer(1,T3MovingBuffer);
   SetIndexBuffer(2,LowerBuffer  );
   SetIndexBuffer(3,Series_buffer);
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int drawbegin=100+Bands_Shift; 
   SetIndexDrawBegin(0,drawbegin);
   SetIndexDrawBegin(1,drawbegin);
   SetIndexDrawBegin(2,drawbegin);
// the horizontal shift of the indicator lines
   SetIndexShift (0, Bands_Shift); 
   SetIndexShift (1, Bands_Shift); 
   SetIndexShift (2, Bands_Shift); 
// name for the windows of data and leyba for sub"okon
   IndicatorShortName ("T3Bollinger Bands( Period="+Bands_Period+", Deviations="+Bands_Deviations+")"); 
   SetIndexLabel (0, "Upper Bands"); 
   SetIndexLabel (2, "Lower Bands"); 
   string Moving;
   switch(MA_method)
           {
            case  0: Moving= "T3SMA";break;
            case  1: Moving= "T3EMA";break;
            case  2: Moving="T3SSMA";break;
            case  3: Moving="T3LWMA";break;
            default: Moving="T3SMA";
           }
   SetIndexLabel (1, "T3Moving Avereges "+Moving+" ("+Bands_Period+")");
// the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
// a change in the sizes of the buffer variables of function T3Series,nT3.number=3(Tri turning to function T3Series)
   if (Bands_Smooth<=1){if (T3SeriesResize(1)!=1)return(-1);}else if (T3SeriesResize(3)!=3)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
   T3SeriesAlert(0,"MA_Smooth",MA_Smooth);
   T3SeriesAlert(0,"Bands_Period",Bands_Period);
   if((MA_method<0)||(MA_method>3))
         {Alert("???????? MA_method ?????? ???? ?? 0 ?? 3"+" ?? ????? ???????????? " 
                                                               +MA_method+ " ????? ???????????? 0");}
   PriceSeriesAlert(Input_Price_Customs);
// korektsiya of the inadmissible value of parameter Bands_.Period
   if(Bands_Period<1)Bands_Period=1; 
// the completion of the initialization
   return(0);
  }
//------------------------------------------------------------------
//| T3.2Bollinger Bands iteration function |
//------------------------------------------------------------------
int start()
  {
// checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=Bands_Period) return(0);
// the introduction of variables with the floating point
double deviation,Temp_Series,sum,midline,priceswing,Resalt;
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,MaxBarBB,bar,kk,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
// (without this conversion for counted_.bars function T3Series it willwork incorrectly!!!)
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1;MaxBar=Bars-1-Bands_Period;MaxBarBB=MaxBar-30;
// the load of input prices into the buffer for the calculation
for(bar=limit;bar>=0;bar--)Series_buffer[bar]=PriceSeries(Input_Price_Customs,bar);
// checking bar to the sufficiency for calculation Bollinger Bands
// initialization of zero
if (limit>MaxBar)
     {
      for(bar=limit;bar>=MaxBar;bar--)T3MovingBuffer[bar]=0;
      limit=MaxBar;
     }
// the cycle of calculation Moving Avereges
for(bar=limit;bar>=0;bar--)
     {
// formula for calculation Moving Avereges
      Temp_Series=iMAOnArray(Series_buffer,0,Bands_Period,0,MA_method, bar);
// the smoothing of that obtained Moving Avereges
// turning to function T3Series after number 0. Parametr.s nT3.Lengthnot menya.ttsya on each bar (nT3.din=0)
      Resalt=T3Series(0,0,MaxBar,limit,Smooth_Curvature,MA_Smooth,Temp_Series,bar,reset);
// checking to the absence of error in the previous operation
      if(reset!=0)return(-1); 
      T3MovingBuffer[bar]=Resalt; 
     }     
// CALCULATION Bollinger Bands
// initialization of zero
if (limit>MaxBarBB)
     {

      for(bar=limit;bar>=MaxBarBB;bar--)
       {
        UpperBuffer[bar]=0;
        LowerBuffer[bar]=0;
       }
      limit=MaxBarBB;
     }
for(bar=limit;bar>=0;bar--)
     {         
      sum=0.0;
      midline=T3MovingBuffer[bar];
      kk=bar+Bands_Period-1;
      while(kk>=bar)
        {
         priceswing=PriceSeries(Input_Price_Customs,kk)-midline;
         sum+=priceswing*priceswing;
         kk--;
        }  
      deviation=Bands_Deviations*MathSqrt(sum/Bands_Period);    
      if (Bands_Smooth>1)
        {    
// calculation and JMA smoothing Bollinger Bands
//----------------------------------------------------------------------------------------
// two parallel turnings to function T3Series after numbers 1, 2.
// parameters nJMACurvature and nJMA.Length do not change on each bar(nJMA.din=0)
//----------------------------------------------------------------------------------------
         Resalt=T3Series(1,0,MaxBarBB-1,limit,Smooth_Curvature,Bands_Smooth ,midline+deviation,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); UpperBuffer[bar]=Resalt; 
//----------------------------------------------------------------------------------------
         Resalt=T3Series(2,0,MaxBarBB-1,limit,Smooth_Curvature,Bands_Smooth ,midline-deviation,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); LowerBuffer[bar]=Resalt; 
//----------------------------------------------------------------------------------------
        }
      else 
        {
// calculation Bollinger Bands without JMA smoothing
         UpperBuffer[bar]=midline+deviation;
         LowerBuffer[bar]=midline-deviation;
        }

    }
// the completion of the calculations of the values of the indicator
   return(0);
  }
//---------------------------------------------------------------------------

