/*
For the work of indicator should be placed the files
T3Series.mqh
PriceSeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.indicators \
*/
//------------------------------------------------------------------
//| T3Moving Avereges_.Channel.mq4 |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 3
// the color of the indicator
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Lime
// the style of the lines of the indicator
#property indicator_style1 0
#property indicator_style2 4
#property indicator_style3 4
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Channel_.width = 40; //the width of channel in the points
extern int MA_.period = 100; //the depth of the first smoothing
extern int MA_.method = 0; //the method of the averaging
extern int Smooth = 20; //the depth of the smoothing
extern int Smooth_.Curvature = y00;// the parameter of smoothing,influences the quality of transient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
//yy-.Yueiken Ashi High, y2-.Yueiken Ashi Low, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.)
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double Series_buffer[];
double T3MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
// constant with the floating point
double Half_Width;
//------------------------------------------------------------------
// introduction to function T3Series
// introduction to function T3SeriesResize
// introduction to function T3SeriesAlert
// introduction to function T3_.ErrDescr
#include <T3Series.mqh> 
//------------------------------------------------------------------
// introduction to function PriceSeries
// introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//------------------------------------------------------------------
//| T3Moving Avereges_.Channel initialization function |
//------------------------------------------------------------------
int init() 
{  
// the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE);
SetIndexStyle (1,DRAW_LINE);
SetIndexStyle (2,DRAW_LINE); 
// 4 indicator buffers of ispol'zovan.s for the calculation
IndicatorBuffers(4);
SetIndexBuffer(0,T3MovingBuffer);  
SetIndexBuffer(1,UpperBuffer); 
SetIndexBuffer(2,LowerBuffer); 
SetIndexBuffer(3,Series_buffer);
// the horizontal shift of the indicator lines
SetIndexShift (0, Shift);  
SetIndexShift (1, Shift);
SetIndexShift (2, Shift);
// the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0); 
SetIndexEmptyValue(1,0);
SetIndexEmptyValue(2,0);
// name for the windows of data and leyba for sub"okon
string Moving;
switch(MA_method)
  {
    case  0: Moving= "T3SMA";break;
    case  1: Moving= "T3EMA";break;
    case  2: Moving="T3SSMA";break;
    case  3: Moving="T3LWMA";break;
    default: Moving="T3SMA";
  }
IndicatorShortName (""+Moving+"_Channel( Channel_width="+Channel_width+", MA_period="+MA_period+", Shift="+Shift+")"); 
SetIndexLabel (0, ""+Moving+" ("+MA_period+")");
SetIndexLabel (1, "Upper"); 
SetIndexLabel (2, "Lower"); 
// the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
// a change in the sizes of the buffer variables of function T3Series,nT3.number=1(Odno turning to function T3Series)
if (T3SeriesResize(1)!=1)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
T3SeriesAlert (0,"Smooth",Smooth);
T3SeriesAlert (0,"MA_period",MA_period);
PriceSeriesAlert(Input_Price_Customs);
if((MA_method<0)||(MA_method>3))
       Alert("???????? MA_method ?????? ???? ?? 0 ?? 3"+" ?? ????? ???????????? " 
                                                           +MA_method+ " ????? ???????????? 0");
// korektsiya of the inadmissible value of parameter MA_.period
if(MA_period<1)MA_period=1; 
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
int draw_begin=MA_period+30; 
SetIndexDrawBegin(0,draw_begin);
SetIndexDrawBegin(1,draw_begin);
SetIndexDrawBegin(2,draw_begin); 
// the size of channel in the points
Half_Width = Channel_width*Point/2;
// the completion of the initialization
return(0); 
} 
//------------------------------------------------------------------
//| T3Moving Avereges_.Channel iteration function |
//------------------------------------------------------------------
int start() 
{ 
// checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=MA_period) return(0);
// the introduction of variables with the floating point
double Temp_Series,Resalt;
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,bar,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
//(bez of this conversion for counted_.bars function T3Series willwork incorrectly!!!)
if (counted_bars>0)counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1; MaxBar=Bars-1-MA_period; 
// load into the buffer of the initial prices
for(bar=limit;bar>=0;bar--)Series_buffer[bar]=PriceSeries(Input_Price_Customs,bar);
// korektsiya of the starting raschetogo bar in the cycle
// initialization of zero
if (limit>=MaxBar)
  {
   for(bar=limit;bar>=MaxBar;bar--)
     {
      T3MovingBuffer[bar]=0.0;
      UpperBuffer   [bar]=0.0; 
      LowerBuffer   [bar]=0.0;
     }
   limit=MaxBar;
  }

// THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(bar=limit;bar>=0;bar--)
  {
// formula for calculating the indicator
   Temp_Series=iMAOnArray(Series_buffer,0,MA_period,0,MA_method, bar);
// the smoothing of that obtained Moving Avereges
// turning to function T3Series after number 0. Parameters nT3.Lengthand nT3.Phase not menya.ttsya on each bar (nT3.din=0)
   Resalt=T3Series(0,0,MaxBar,limit,Smooth_Curvature,Smooth,Temp_Series,bar,reset);
// checking to the absence of error in the previous operation
   if(reset!=0)return(-1); 
   T3MovingBuffer[bar]=Resalt; 
// channel design
   UpperBuffer[bar]=Resalt+Half_Width;     
   LowerBuffer[bar]=Resalt-Half_Width;
// the completion of the calculations of the values of the indicator
  }
// the completion of the calculations of the values of the indicator
return(0); 
} 

//---------------------------------------------------------------------------

