/*
For the work of indicator should be placed the files

JJMASeries.mqh
PriceSeries.mqh
FiltersLibroary.mqh
in the folder (directory): MetaTrader\.experts\.include \

Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.experts\.indicators \

DF.DLL
BDSP.DLL
LAPACK.DLL
mkl_.support.dll
in the folder (directory): MetaTrader\.experts\.libraries \
*/
//------------------------------------------------------------------
//| Digital Low Pass (FATL/SATL, KGLP) Filter JDFilter.mq4 |
//| Digital Filter: Copyright (c) Sergey Iljukhin, Novosibirsk. |
//| mailto:sergey@tibet.ru http://fx.qrz.ru/ |
//| JJMASeries: Copyright ? 2005, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "mailto:sergey@tibet.ru"
/*
Digital filters for MetaTrader 4.
 
Attention! For the work it is required three additional DLL
containing the block of mathematical working - bdsp.dll, lapack.dll,mkl_.support.dll,
which must be established in C:\.Windows\.System32 \ or next to DF.dllinto \.ekhperts\.librariyes \
 
Before the use you will be convinced:
  
1. that are established points "Allow DLL import" and"CoFilter_.sizeirm DLL function's call" in tuning Options- ExpertAdvisors
2. that in directory C:\.Windows\.System32 \ there are Bdsp.dll,lapack.dll, mkl_.support.dll - auxiliary mathematical libraries.
 
Description of the input parameters:
  
Ftype - type of the filter: 0 - FNCH (FATL/SATL/KGLP), 1 - FVCH(KGHP),
2 - band (RBCI/KGBP), 3 - rejector (KGBS)
P1 - period of cutoff P1, bars
D1 - period of the cutoff of the transient process of D1, the bar
A1 - damping in the strip of delay Ay, dB
P2 - period of cutoff P2, bars
D2 - period of the cutoff of the transient process of D2, the bar
A2 - damping in the strip of delay A2, dB
Ripple - beatings in the passband, dB
Delay - delay, the bar

For FNCH and FVCH of the value of the parametroy P2.d2.a2 are ignored
Working conditions:
FNCH: P1 D1
FVCH: P1
Band and rejector: D2 P2 P1 D1
*/
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Magenta
#import "DF.dll"
int DigitalFilter(int FType, int P1, int D1, int A1, int P2, int D2, int A2, double Ripple, int Delay, double& arr[]); 
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Length = 5; //the depth of the first smoothing
extern int Phase = 100; //the parameter of the first smoothing, whichis changed within limits of -100... 100, influence the quality oftransient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
//yy-.Yueiken Ashi High, y2-.Yueiken Ashi Low, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.)
extern int FilterType = 0; //Tip of filter with the finishedparameters. Yesi the parameters are placed by hand, then it follows tomake FilterType = 0
//
//we indicate the parameters of the filter
extern int FType=0;//Tip filter: 0 - FNCH (FATL/SATL/KGLP), 1 - FVCH(KGHP), 2 - BAND (RBCI/KGBP), 3 - REJECTOR (KGBS)
extern int P1=28;//Period cutoff P1, bars
extern int D1=19;//Period cutoff of the transient process of D1, thebar
extern int A1=40;//Zatuxanie in the strip of delay Ay, dB
extern int P2=0;//Period cutoff P2, bars
extern int D2=0;//Period cutoff of the transient process of D2, thebar
extern int A2=0;//Zatuxanie in the strip of delay A2, dB
extern int Delay=0;//Zaderjka, the bar
extern double Ripple=0.08;//Bieni4 in the passband, dB
extern bool Print_.Filter=.false;/* the press the parameters of filterinto LOG file of the periodical of experts in the folder of\.MetaTrader\.GBPZhPY\.EKhPERTS\.LOGS
one should not the parameter "Print_.Filter" leave with equal "true",after tuning of indicator. "FALSE" - THE PROHIBITION OF THE PRESS THEPARAMETERS,
"true" THE PRESS THE PARAMETERS */
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double Filter_Buffer[];
// the variables
double Filter[1500];
int Filter_size;
//------------------------------------------------------------------
// introduction to function JJMASeries
// introduction to function JJMASeriesResize
// introduction to function JJMASeriesAlert
// introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//------------------------------------------------------------------
// introduction to function PriceSeries
// introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//------------------------------------------------------------------
//| JDFilter initialization function |
//------------------------------------------------------------------
int init()
{

//=== the initialization of the coefficients of the digital filter of=======
//------
switch(FilterType)
{
//-------------------------------------
case 1:{P1=10;D1=08;Ripple=0.864;}break;
//-------------------------------------
case e:{.Py="9;.Dy=eshch;.Ripple=0.0e9;}.break;//.Satl
//-------------------------------------
// the introduction of the library of finished filters,
// file FiltersLibroary.mqh should be assumed into the folder(directory): MetaTrader\.experts\.include
#include <FiltersLibroary.mqh>
//------
default:{  }
//-------------------------------------
} 
//=========================================================
// checking the call of function from DLL library
  if(IsDllsAllowed()!=false)
  {
// the installation of the style of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
// IndexShift
   SetIndexShift(0,Shift);   
// the determination of buffer for the calculation
   SetIndexBuffer(0, Filter_Buffer);
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0.0); 
// the calculation of digital filter and determining the dimension ofbuffer Filter[
   Filter_size=DigitalFilter(FType, P1, D1, A1, P2, D2, A2, Ripple, Delay, Filter);  
// a change in the size of buffer under the required quantity ofkoeffitsiyetov of the digital filter
   if (Filter_size>0){if(ArrayResize(Filter,Filter_size+1)==0){Print("It is not possible to isolate memory under massif Filter");
   else{Print("The input parameters are incorrect. Indicator cannot be carried out.");
//
   SetIndexDrawBegin(0, Filter_size+30);
// name for the windows of data and leyba for sub"okon
   SetIndexLabel(0,"Digital Low Pass (FATL/SATL, KGLP) Filter");
   IndicatorShortName("Digital Filter");
  }  
  else{Print("Call from libraries (DLL) is impossible. Indicator cannot be carriedout.");
// the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
  IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
// a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
  if (JJMASeriesResize(1)!=1)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
  JJMASeriesAlert (0,"Length",Length);
  JJMASeriesAlert (1,"Phase", Phase);
  PriceSeriesAlert(Input_Price_Customs);
  
// the press the parameters of digital filter into log file in thefolder of \.MetaTrader\.GBPZhPY\.EKhPERTS\.LOGS
if (Print_Filter==true)
{
Print("-------------------------------------------------------------------------");
Print("+<<<<<<<<<<<<<<<<< ?????? ?????????? ????????? ??????? >>>>>>>>>>>>>>>>>>>");
Print("-------------------------------------------------------------------------");
Print("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --");
Print("------------------- of --------------------------");
Print("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --");
Print(".FType =" FType "///the type of the filter: 0 - FNCH(FATL/SATL/KGLP), 1 - FVCH (KGHP),");
Print("                       2 - ????????? (RBCI/KGBP), 3 - ??????????? (KGBS)"  );
Print(".P1 =" P1 "///the period of cutoff P1, of bars");
Print(".D1 =" D1 "///the period of the cutoff of the transient processof D1, bar");
Print(".A1 =" A1 "///damping in the strip of delay Ay, of dB");
Print(".P2 =" P2 "///the period of cutoff P2, of bars");
Print(".D2 =" D2 "///the period of the cutoff of the transient processof D2, bar");
Print(".A2 =" A2 "///damping in the strip of delay A2, of dB");
Print(".Delay =" Delay "///delay, bar");
Print(".Ripple =" Ripple "///beatings in the passband, dB");
double VEL;
for(int iii=0;iii<Filter_size;iii++)
 {
  VEL=Filter[iii];
  Print("-------------------------------------------------------------------------");
  Print("------------- of -------------");
Print("/// Filter is calculated in terms of the variable Cloze[ ]--------------------------");
  Print("-------------------------------------------------------------------------");
  Print("FILTER =");
  if (iii<Filter_size-1)
   {
    if (VEL>=0)Print(""DoubleToStr(.VEL, 8)" * Close[.bar "III"");
    else Print(""DoubleToStr(.VEL, 8)" * Close[.bar "III"");
   }
  else
   {
    if (VEL>=0)Print(""DoubleToStr(.VEL, 8)" * Close[.bar "III" ];");
    else Print(""DoubleToStr(.VEL, 8)" * Close[.bar "III" ];");
   }
  Print("-------------------------------------------------------------------------");
  Print("------------- of -------------");
Print("/// Filter is calculated in terms of the variableSeries_.Buffer[ ] ------------------");
  Print("-------------------------------------------------------------------------");
  Print("FILTER =");
  if (iii<Filter_size-1)
   {
    if (VEL>=0)Print(""DoubleToStr(.VEL, 8)" * Series_.Buffer[.bar "III"");
    else Print(""DoubleToStr(.VEL, 8)" * Series_.Buffer[.bar "III"");
   }
  else
   {
    if (VEL>=0)Print(""DoubleToStr(.VEL, 8)" * Series_.Buffer[.bar "III" ];");
    else Print(""DoubleToStr(.VEL, 8)" * Series_.Buffer[.bar "III" ];");
   }
  Print("-------------------------------------------------------------------------");
  Print("------------- of -------------");
Print("/// Filter is calculated according to function PriceSeries of-------------------------");
  Print("-------------------------------------------------------------------------");
  Print("FILTER =");
  if (iii<Filter_size-1)
   {
    if (VEL>=0)Print(""DoubleToStr(.VEL, 8)" * PriceSeries(.Input_.Price_.Customs, bar "III");
    else Print(""DoubleToStr(.VEL, 8)" * PriceSeries(.Input_.Price_.Customs, bar "III");
   }
  else
   {
    if (VEL>=0)Print(""DoubleToStr(.VEL, 8)" * PriceSeries(.Input_.Price_.Customs, bar "III");
    else Print(""DoubleToStr(.VEL, 8)" * PriceSeries(.Input_.Price_.Customs, bar "III");
   }
   Print("-------------------------------------------------------------------------");
   Print("---------- of -----------");
   Print("-------------------------------------------------------------------------");
   Print("Filter_.size = "Filter_.size";");
   {
    if (VEL>=0)Print("Filter[ "III" ] = "DoubleToStr(.VEL, 8)";");
    else Print("Filter[ "III" ] = "DoubleToStr(.VEL, 8)";");
   }
   Print("-------------------------------------------------------------------------");
   Print("+<<<<<<<<<<<<<<  ר    >>>>>>>>>>>>>>+");
   Print("+-------------------------------------------------------------------------");
  }
}
//---- 

//----  
return(0); 
} 
//+------------------------------------------------------------------+  
//| JDFilter                                                         | 
//+------------------------------------------------------------------+  
int start()
   {
//----       
if(Bars-1<=Filter_size)return(0);  
//----      
double Price,FILTER,Resalt;
//----+        
int reset,MaxBar,limit,bar,counted_bars=IndicatorCounted();
//----    
if (counted_bars<0)return(-1);
//----      
if (counted_bars>0) counted_bars--;
//----     ,         
MaxBar=Bars-1-Filter_size;
//----     ,         
limit=Bars-counted_bars-1; 
//----      ,         
//----            
if (limit>=MaxBar)
 {
  for(bar=limit;bar>=MaxBar;bar--)Filter_Buffer[bar]=0.0; 
  limit=MaxBar;
 }

//----+    
for(bar=limit;bar>=0;bar--)
 {
 FILTER=0.0;
  for(int ii=0;ii<=Filter_size;ii++)
   {
    //----+    PriceSeries     Price
    Price=PriceSeries(Input_Price_Customs, bar+ii);
    //----+     
    FILTER=FILTER+Filter[ii]*Price;
   }
  //----+ JMA   ,  nJMA.MaxBar     Filter_size
  //----+    JJMASeries   0,  nJMA.Phase  nJMA.Length      (nJMA.din=0)
  Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,FILTER,bar,reset);
  //----+       
  if(reset!=0)return(-1);
  Filter_Buffer[bar]=Resalt;
     //----+
 }
//----    
return(0); 
} 
//+-------------------------------------------------------------+