/*
Operating indicator should put files

JJMASeries.mqh
PriceSeries.mqh
FiltersLibroary.mqh
in the folder (directory) : MetaTrader \ experts \ include \

Heiken Ashi #. Mh4
in the folder (directory) : MetaTrader \ experts \ indicators \

DF.DLL
BDSP.DLL
LAPACK.DLL
mkl_support.dll
in the folder (directory) : MetaTrader \ experts \ libraries \
*/
// ---------------------------------------- --------------------------
// | Digital Low Pass (FATL / SATL, KGLP) JDFilter.mq4 Filter |
// | Digital Filter : Copyright (c) Sergey Iljukhin, Novosibirsk. |
// | mailto : sergey@tibet.ru http://fx.qrz.ru/ |
// | JJMASeries Print_Filter : Copyright ? 2005, Nikolay Kositsin |
// | Khabarovsk, farria@mail.redcom.ru |
// ---------------------------------------- --------------------------
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "mailto:sergey@tibet.ru"
/*
Digital filters to MetaTrader 4.
 
Attention! For requires three additional DLL
block containing mathematical treatment-bdsp.dll, lapack.dll, mkl_support.dll,
to be installed in the C : \ Windows \ System32 \ or close to DF.dll to \ experts \ libraries \
 
Before using, make sure :
  
1. that the settlements Allow DLL import and CoFilter_sizeirm DLL function&#39;s call in your Options- Expert Advisors
2. With the directory C : \ Windows \ System32 \ Bdsp.dll there, lapack.dll, mkl_support.dll Support mathematical library.
 
The input parameters :
  
Ftype-Filter Type : 0-gating (FATL / SATL / KGLP), 1 FHP (KGHP)
2-flat (RBCI / KGBP), 3-notch (KGBS)
P1 - Period cut P1, bar
D1 - Period cut transition D1 bar
A1-Attenuation in the late A1, dB
P2 - Period cut P2, bar
D2 - Period cut transition D2, bar
A2-Attenuation in the late A2, B
Ripple-Bienia in bandwidth dB
Delay - Delay, bar

For gating and the FHP parametroy P2, D2, A2 ignored
Working conditions :
LPF : P1 D1
FHP : P1 D1
Flat and notch : D2 P2 P1 D1
*/
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Magenta
#import "DF.dll"
int DigitalFilter(int FType, int P1, int D1, int A1, int P2, int D2, int A2, double Ripple, int Delay, double& arr[]); 
//---- INPUT PARAMETERS INDIKATORA ---------------------------------------- ---------------------------------------- ------------------
extern int Length = 5; // depth of the first bridge
extern int Phase = 100; // first parameter smoothing, changing in the -100 ... 100, affect the quality of the transitional process;
extern int Shift = 0; // cdwig lights along the axis of time
extern int Input_Price_Customs = 0; // The prices at which are used to calculate the indicator
// (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5 * TRENDFOLLOW,
// 11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close).
extern int FilterType = 0; // Filter Type ready with parameters. Screening parameters are manually, it should be done FilterType = 0
//----
// Ukasavaem filter options
extern int FType = 0; // Filter Type : 0-gating (FATL / SATL / KGLP), 1 FHP (KGHP), 2-flat (RBCI / KGBP), 3-notch (KGBS)
extern int P1 = 28; // The cut P1, bar
extern int D1 = 19; // The cut transition D1 bar
extern int A1 = 40; // Attenuation in the late A1, dB
extern int P2 = 0; // The cut P2, bar
extern int D2 = 0; // The cut transition D2, bar
extern int A2 = 0; // Attenuation in the late A2, B
extern int Delay = 0; // Delay bar
extern double Ripple = 0.08; // Bienia in bandwidth dB
extern Print_Filter bool = false; /* print filter parameters in the LOG file magazine experts in the folder \ MetaTrader \ GBPJPY \ EXPERTS \ LOGS
deprecated the Print_Filter leave equal true, after setting indicator. false - PROHIBITION OF PRESS,
true SEAL OF */
//---- ---------------------------------------- ---------------------------------------- ---------------------------------------- -------
//---- indicator buffers
double Filter_Buffer[];
//---- variables
double Filter[1500];
int Filter_size;
// ---------------------------------------- --------------------------
//---- Introduction of JJMASeries
//---- Introduction of JJMASeriesResize
//---- Introduction of JJMASeriesAlert
//---- Introduction of JMA_ErrDescr
#include <JJMASeries.mqh> 
// ---------------------------------------- --------------------------
//---- Introduction of PriceSeries
//---- Introduction of PriceSeriesAlert
#include <PriceSeries.mqh>
// ---------------------------------------- --------------------------
// | JDFilter initialization function |
// ---------------------------------------- --------------------------
int init()
{

// === Initialization coefficients digital filter =======
// ------
switch(FilterType)
{
// -------------------------------------
case 1:{P1=10;D1=08;Ripple=0.864;}break;
// -------------------------------------
case 3 : (P1 = 79; D1 = 35; Ripple = 0.039;) break; // Sat l
// -------------------------------------
//---- The library would filters
//---- FiltersLibroary.mqh file should be put into a folder (directory) : MetaTrader \ experts \ include
#include <FiltersLibroary.mqh>
// ------
default:{  }
// -------------------------------------
} 
// ======================================== =================
//---- checking function call from a DLL library
  if(IsDllsAllowed()!=false)
  {
//---- installation style images indicator
   SetIndexStyle(0,DRAW_LINE);
//---- IndexShift
   SetIndexShift(0,Shift);   
//---- a buffer for counting
   SetIndexBuffer(0, Filter_Buffer);
//---- installation of the light, which will not be visible on the graph
   SetIndexEmptyValue(0,0.0); 
Calculating //---- digital filter and the size buffer Filter []
   Filter_size=DigitalFilter(FType, P1, D1, A1, P2, D2, A2, Ripple, Delay, Filter);  
//---- change in the buffer to the required number koeffizietov digital filter
   if (Filter_size>0){if(ArrayResize(Filter,Filter_size+1)==0){Print("It is impossible to separate the memory array Filter");
   else{Print("Input incorrect. Indicator can not be implemented.");
//----
   SetIndexDrawBegin(0, Filter_size+30);
//---- name for the window and leiba for subjokon
   SetIndexLabel(0,"Digital Low Pass (FATL/SATL, KGLP) Filter");
   IndicatorShortName("Digital Filter");
  }  
  else{Print("Call Library (DLL) is not possible. Indicator can not be implemented.");
//---- Installation of accuracy (number of places) for the visualization of the indicator
  IndicatorDigits(Digits);
//---- Change buffer size variable functions JJMASeries, nJMAnumber = 1 (One recourse to the JJMASeries)
  if (JJMASeriesResize(1)!=1)return(-1);
//---- installation alertov unacceptable to the external variables
  JJMASeriesAlert (0,"Length",Length);
  JJMASeriesAlert (1,"Phase", Phase);
  PriceSeriesAlert(Input_Price_Customs);
  
//---- Press the digital filter in a log file to \ MetaTrader \ GBPJPY \ EXPERTS \ LOGS
if (Print_Filter==true)
{
Print("---------------------------------------- ---------------------------------");
Print(" CALCULATION OF DIGITAL FILTER ");
Print("---------------------------------------- ---------------------------------");
Print("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --");
Print("------------------- baseline parameters --------------------------");
Print("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --");
Print ( FType = FType // / Filter Type : 0-gating (FATL / SATL / KGLP), 1 FHP (KGHP), );
Print("                       2 - ????????? (RBCI/KGBP), 3 - ??????????? (KGBS)"  );
Print (P1 = P1 // / The cut P1, bar );
Print (D1 = D1 // / The cut transition D1 bar );
Print (A1 = A1 // / Attenuation in the late A1, B);
Print ( P2 = P2 // / The cut P2, bar);
Print (D2 = D2 // / The cut transition D2, bar );
Print (A2 = A2 // / Attenuation in the late A2, B);
Print ( Delay = Delay // / Delay, bar);
Print ( Ripple = Ripple // / Bienia in bandwidth dB);
double VEL;
for(int iii=0;iii<Filter_size;iii++)
 {
  VEL=Filter[iii];
  Print("---------------------------------------- ---------------------------------");
  Print("------------- The formula for raceta filter -------------");
Print (/// Filter calculated for the variable Cloze [] -------------------------- );
  Print("---------------------------------------- ---------------------------------");
  Print("FILTER =");
  if (iii<Filter_size-1)
   {
    if (VEL>=0)Print("DoubleToStr (VEL .8) * Close [bar iii]");
    else Print("DoubleToStr (VEL .8) * Close [bar iii]");
   }
  else
   {
    if (VEL>=0)Print("DoubleToStr (VEL .8) * Close [bar iii ];");
    else Print("DoubleToStr (VEL .8) * Close [bar iii ];");
   }
  Print("---------------------------------------- ---------------------------------");
  Print("------------- The formula for raceta filter -------------");
Print (/// Filter calculated for the variable Series_Buffer [] ------------------ );
  Print("---------------------------------------- ---------------------------------");
  Print("FILTER =");
  if (iii<Filter_size-1)
   {
    if (VEL>=0)Print("DoubleToStr (VEL .8) * Series_Buffer [bar iii]");
    else Print("DoubleToStr (VEL .8) * Series_Buffer [bar iii]");
   }
  else
   {
    if (VEL>=0)Print("DoubleToStr (VEL .8) * Series_Buffer [bar iii ];");
    else Print("DoubleToStr (VEL .8) * Series_Buffer [bar iii ];");
   }
  Print("---------------------------------------- ---------------------------------");
  Print("------------- The formula for raceta filter -------------");
Print (/// Filter calculated on the PriceSeries ------------------------- );
  Print("---------------------------------------- ---------------------------------");
  Print("FILTER =");
  if (iii<Filter_size-1)
   {
    if (VEL>=0)Print("DoubleToStr (VEL .8) * PriceSeries (Input_Price_Customs, bar iii");
    else Print("DoubleToStr (VEL .8) * PriceSeries (Input_Price_Customs, bar iii");
   }
  else
   {
    if (VEL>=0)Print("DoubleToStr (VEL .8) * PriceSeries (Input_Price_Customs, bar iii");
    else Print("DoubleToStr (VEL .8) * PriceSeries (Input_Price_Customs, bar iii");
   }
   Print("---------------------------------------- ---------------------------------");
   Print("---------- The coefficients for raceta filter -----------");
   Print("---------------------------------------- ---------------------------------");
   Print("Filter_size = Filter_size;");
   {
    if (VEL>=0)Print("Filter [iii] = DoubleToStr (VEL .8);");
    else Print("Filter [iii] = DoubleToStr (VEL .8);");
   }
   Print("---------------------------------------- ---------------------------------");
   Print(" FOR END OF DIGITAL FILTER ");
   Print("---------------------------------------- ---------------------------------");
  }
}
//----

//---- completion of initialization
return(0); 
} 
// ---------------------------------------- --------------------------
// | JDFilter |
// ---------------------------------------- --------------------------
int start()
   {
//---- verification of the bar sufficiency for the calculation
if(Bars-1<=Filter_size)return(0);  
//---- Introduction variables the float
double Price,FILTER,Resalt;
//---- The entire variables and the already counted bars
int reset,MaxBar,limit,bar,counted_bars=IndicatorCounted();
//---- checking for possible errors
if (counted_bars<0)return(-1);
Last //---- poschitanny bar should be restated
if (counted_bars>0) counted_bars--;
//---- caller ID the old bar from which will be re proizeden all bars
MaxBar=Bars-1-Filter_size;
//---- caller ID the old bar from which will proizeden conversion only to new bars
limit=Bars-counted_bars-1; 
//---- korekcia maximum number of the old bar from which will be re proizeden new bars
//---- create zero
if (limit>=MaxBar)
 {
  for(bar=limit;bar>=MaxBar;bar--)Filter_Buffer[bar]=0.0; 
  limit=MaxBar;
 }

//---- basic cycle indicator calculation
for(bar=limit;bar>=0;bar--)
 {
 FILTER=0.0;
  for(int ii=0;ii<=Filter_size;ii++)
   {
//---- Resort to the PriceSeries for input prices Price
    Price=PriceSeries(Input_Price_Customs, bar+ii);
//---- formula for the digital filter
    FILTER=FILTER+Filter[ii]*Price;
   }
//---- JMA received smoothing indicator parameter nJMA.MaxBar reduced to the size of the filter Filter_size
//---- Resort to the JJMASeries No. 0, the nJMA.Phase and nJMA.Length not changing every bar (nJMA.din = 0)
  Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,FILTER,bar,reset);
//---- checking for the absence of errors in the previous operation
  if(reset!=0)return(-1);
  Filter_Buffer[bar]=Resalt;
//----
 }
//---- completion calculations of the indicator
return(0); 
} 
// ---------------------------------------- -----------------------------------

