/*
For the work of indicator should be placed the files
JLiteSeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                      J2JLite.mq4 | 
//|                               Copyright ? 2006, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Magenta 
//THE INPUT PARAMETERS OF THE INDICATOR OF-----------------------------------------------------------------------------------------------------
extern int Length1 = 5; //the depth of the first smoothing
extern int Length2 = 5; //the depth of the second smoothing
extern int Phase1 = 100; //the parameter of the first smoothing, whichis changed within limits of -100... 100, influence the quality oftransient process;
extern int Phase2 = 100; //the parameter of the second smoothing,which is changed within limits of -100... 100, influence the qualityof transient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- +---------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double J2JLite[];
//variables with the floating point
double Temp_Series;
//+------------------------------------------------------------------+  
//introduction to function JLiteSeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
#include <JLiteSeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| J2JLite indicator initialization function                        | 
//+------------------------------------------------------------------+  
int init() 
{  
//the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE); 
//1 indicator buffer is used for the calculation
SetIndexBuffer(0,J2JLite);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift);  
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0); 
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("J2JLite( Length1="+Length1+", Phase1="+Phase1+", Length2="+Length2+", Phase2="+Phase2+", Shift="+Shift+")"); 
SetIndexLabel (0, "J2JLite"); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Length1",Length1);
JJMASeriesAlert (0,"Length2",Length2);
JJMASeriesAlert (1,"Phase1", Phase1 );
JJMASeriesAlert (1,"Phase2", Phase2 );
PriceSeriesAlert(Input_Price_Customs);
//a change in the sizes of the buffer variables of functionJLiteSeries, nJMAnumber=2(Dva turning to function JLiteSeries)
if (JJMASeriesResize(2)!=2)return(-1);
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| J2JLite iteration function                                       | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<61)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar1,MaxBar2,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
//(without this conversion for counted_.bars function JLiteSeries itwill work incorrectly!!!)
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1; MaxBar1=Bars-1; MaxBar2=MaxBar1-30;

//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(int bar=limit;bar>=0;bar--)
{
//turning to function PriceSeries for obtaining the input priceSeries
Temp_Series=PriceSeries(Input_Price_Customs, bar);
//+----------------------------------------------------------------------------+ 
//two turnings to function JLiteSeries after numbers 0, 1. ParametersnJLitePhase and nJLiteLength do not change on each bar (nJLitedin=0)
//(Vo the second rotation parameter nJLiteMaxBar is reduced by 30since this repeated JLite smoothing)
//+----------------------------------------------------------------------------+   
Temp_Series=JJMASeries(0,0,MaxBar1,limit,Phase1,Length1,Temp_Series,bar,reset);
//checking to the absence of error in the previous operation
if(reset!=0)return(-1);
//+----------------------------------------------------------------------------+ 
Temp_Series=JJMASeries(1,0,MaxBar2,limit,Phase2,Length2,Temp_Series,bar,reset);
//checking to the absence of error in the previous operation
if(reset!=0)return(-1);
//+----------------------------------------------------------------------------+ 
J2JLite[bar]=Temp_Series;
}
//the completion of the calculations of the values of the indicator
return(0); 
} 
//+---------------------------------------------------------------------+

