/*
For the work of indicator should be placed the files
JJMASeries.mqh and
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                       JFRAMA.mq4 | 
//|                           Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Red  
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int FRAMA_.Period = 10; //period FRAMA
extern int Smooth = 10; //the depth of the first smoothing
extern int Smooth_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of transientprocess;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double FRAMA[];
double Ind_Buffer[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+   
//| JFRAMA indicator initialization function                         | 
//+------------------------------------------------------------------+  
int init() 
{  
//the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE); 
//1 indicator buffer is used for the calculation
IndicatorBuffers(2);
SetIndexBuffer(0,Ind_Buffer);
SetIndexBuffer(1,FRAMA);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift); 
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);    
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("FRAMA( FRAMA_Period="+FRAMA_Period+",  Shift="+Shift+")"); 
SetIndexLabel (0, "FRAMA"); 
//----
IndicatorDigits(Digits);
//the installation of Alerts at the inadmissible values of theexternal variables
PriceSeriesAlert(Input_Price_Customs);
JJMASeriesAlert (0,"Smooth",Smooth);
JJMASeriesAlert (1,"Smooth_Phase",Smooth_Phase);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the installation of the values of indicator, which not will be seenon the graph
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| JFRAMA iteration function                                        | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<FRAMA_Period+1)return(0);

double N1,N2,N3,HH,LL,Max,Min,Dimen,alpha,Filt,Filt1,Price,Resalt;
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,bar,limit,iii,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1-FRAMA_Period; limit=MaxBar-counted_bars;
//initialization of zero
if (limit>=MaxBar)
 {
  limit=MaxBar;
  Filt1=PriceSeries(Input_Price_Customs,MaxBar);
  FRAMA[bar]=0;
  Ind_Buffer[bar]=0;
 }
else Filt=FRAMA[limit+1];

//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(bar=limit;bar>=0;bar--)
 {
  //----
  HH = High[bar+FRAMA_Period]; 
  LL = Low [bar+FRAMA_Period]; 
  for(iii = FRAMA_Period; iii>FRAMA_Period / 2; iii--)
   { 
    if (High[bar+iii] > HH) HH = High[bar+iii]; 
    if (Low [bar+iii] < LL) LL = Low [bar+iii];
   } 
  N1 = (HH - LL) / (FRAMA_Period / 2);
  //---- 
  HH = High[bar+FRAMA_Period / 2]; 
  LL = Low [bar+FRAMA_Period / 2]; 
  for(iii = FRAMA_Period / 2; iii >= 0; iii--)
   {
    if (High[bar+iii] > HH) HH = High[bar+iii]; 
    if (Low [bar+iii] < LL) LL = Low [bar+iii];
   } 
  N2 = (HH - LL) / (FRAMA_Period / 2); 
  //----
  Max=High[iHighest(NULL, 0, MODE_HIGH, FRAMA_Period, bar)];
  Min=Low [iLowest (NULL, 0, MODE_LOW,  FRAMA_Period, bar)];
  N3 = (Max - Min) / FRAMA_Period;   
  if ((N1 > 0)&&(N2 > 0)&&(N3 > 0)) Dimen = (MathLog( N1 + N2) - MathLog( N3)) / MathLog( 2); 
  alpha = MathExp(- 4.6*( Dimen - 1)); 
  if (alpha < 0.01)alpha = 0.01; 
  if (alpha > 1   )alpha = 1; 
  //----
  Price=PriceSeries(Input_Price_Customs,bar);
  Filt = alpha* Price + (1 - alpha)* Filt; 
  FRAMA[bar]=Filt;
//JMA the smoothing of the obtained indicator
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMAFRAMA_.Period do not change on each bar(nJMA.din=0)
  Resalt=JJMASeries(0,0,MaxBar,limit,Smooth_Phase,Smooth,Filt,bar,reset);
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1);
  Ind_Buffer[bar]=Resalt;
 }
//the completion of the calculations of the values of the indicator
return(0); 
} 

//+----------------------------------------------------+

