/*
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                        JFatl.mq4 | 
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the basic window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Blue 
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Length = 3; //the depth of the smoothing
extern int Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of transient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the buffers
double JFatl  []; 
double Filter[1];
//the variables
int nf; double FILTER,Price,Resalt;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+   
//| JFATL initialization function                                    |
//+------------------------------------------------------------------+ 
int init() 
{ 
//the installation of the style of the image of the indicator
SetIndexStyle(0,DRAW_LINE); 
//the determination of buffer for the calculation
SetIndexBuffer(0,JFatl);
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);  
//determining the dimension of buffer Filter[
nf=38;.int count=.ArrayResize(.Filter.nfy);.if(.chount==0){.Alert("Nevozmozhno to isolate memory under massifFilter");.return(0);}
//=== the initialization of the coefficients of the digital filter of =======================================================================
Filter[00]=+0.4360409450;Filter[01]=+0.3658689069;Filter[02]=+0.2460452079;Filter[03]=+0.1104506886;Filter[04]=-0.0054034585;
Filter[05]=-0.0760367731;Filter[06]=-0.0933058722;Filter[07]=-0.0670110374;Filter[08]=-0.0190795053;Filter[09]=+0.0259609206;
Filter[10]=+0.0502044896;Filter[11]=+0.0477818607;Filter[12]=+0.0249252327;Filter[13]=-0.0047706151;Filter[14]=-0.0272432537;
Filter[15]=-0.0338917071;Filter[16]=-0.0244141482;Filter[17]=-0.0055774838;Filter[18]=+0.0128149838;Filter[19]=+0.0226522218; 
Filter[20]=+0.0208778257;Filter[21]=+0.0100299086;Filter[22]=-0.0036771622;Filter[23]=-0.0136744850;Filter[24]=-0.0160483392;
Filter[25]=-0.0108597376;Filter[26]=-0.0016060704;Filter[27]=+0.0069480557;Filter[28]=+0.0110573605;Filter[29]=+0.0095711419;
Filter[30]=+0.0040444064;Filter[31]=-0.0023824623;Filter[32]=-0.0067093714;Filter[33]=-0.0072003400;Filter[34]=-0.0047717710;
Filter[35]=+0.0005541115;Filter[36]=+0.0007860160;Filter[37]=+0.0130129076;Filter[38]=+0.0040364019;
//+=========================================================================================================================+
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Length",Length);
JJMASeriesAlert (1,"Phase", Phase);
PriceSeriesAlert(Input_Price_Customs);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
SetIndexDrawBegin(0,nf+30); 
//the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
//the completion of the initialization
return(0); 
}
//+------------------------------------------------------------------+ 
//| JFATL iteration function                                         | 
//+------------------------------------------------------------------+  
int start()
   {
//checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=nf)return(0);  
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,limit,bar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1-nf;
//korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
//initialization of zero
if (limit>=MaxBar)
 {
  for(bar=limit;bar>=MaxBar;bar--)JFatl[bar]=0.0; 
  limit=MaxBar;
 }

//the basic cycle of the calculation of the indicator
for(bar=limit;bar>=0;bar--)
 {
 FILTER=0.0;
  for(int ii=0;ii<=nf;ii++)
   {
//turning to function PriceSeries for obtaining the input priceSeries
    Price=PriceSeries(Input_Price_Customs, bar+ii);
//formula for filter FATL
    FILTER=FILTER+Filter[ii]*Price;
   }
//JMA the smoothing of the obtained indicator, parameter nJMA.MaxBaris reduced by the size of filter nf
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
  Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,FILTER,bar,reset);
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1);
  JFatl[bar]=Resalt;
     //----+
 }
//the completion of the calculations of the values of the indicator
return(0); 
} 
//+-------------------------------------------------------------+

