/*
For the work of indicator should be placed the files
JurXSeries.mqh, 
JJMASeries.mqh, 
PriceSeries.mqh,  
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
At the basis of this indicator the algorithm of smoothing from theindicator lies
JRSX. The eventual result of this algorithm has a certain similaritys
by dual JMA smoothing, but in view of larger simplicity is lessperfect.

*/
//+------------------------------------------------------------------+ 
//|                                                        JJurX.mq4 | 
//|                           Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Gold
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int JurX_.Length = 5; //depth JurX of the smoothing
extern int JJMA_.Length = 4; //depth JJMA of the smoothing
extern int JJMA_.Phase = -y00;///parameter JJMA of smoothing, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer[];
//variables with the floating point
double Price,JurX,JJurX,Error;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+ 
//introduction to function JurXSeries
//introduction to function JurXSeriesResize
//introduction to function JurXSeriesAlert
//introduction to function JurX_.ErrDescr
#include <JurXSeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JJurX indicator initialization function                          | 
//+------------------------------------------------------------------+  
int init() 
{  
//the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE); 
//1 indicator buffer is used for the calculation
SetIndexBuffer(0,Ind_Buffer);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift); 
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0); 
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("JJurX( JurX_Length="+JurX_Length+", Shift="+Shift+")"); 
SetIndexLabel (0, "JJurX"); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//a change in the sizes of the buffer variables of functionJurXSeries, nJurXnumber=2(Dva turning to function JurXSeries)
if (JurXSeriesResize(2)!=2)return(-1);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JurXSeriesAlert(0,"JurX_Length",JurX_Length); 
JJMASeriesAlert(0,"JJMA_Length",JJMA_Length); 
JJMASeriesAlert(1,"JJMA_Phase",JJMA_Phase); 
PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+ 
//| JJurX iteration function                                         | 
//+------------------------------------------------------------------+ 
int start() 
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<JurX_Length+32)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted (without this conversionfor counted_.bars function JurXSeries it will work incorrectly!!!)
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1; MaxBar=Bars-1; 

//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(int bar=limit;bar>=0;bar--)
 {
//turning to function PriceSeries for obtaining the input priceSeries
  Price=PriceSeries(Input_Price_Customs,bar);
//one turning to function JurXSeries after number 0. ParameternJJurX.Length not menya.ttsya on each bar (nJurXdin=0)
  JurX=JurXSeries(0,0,MaxBar,limit,JurX_Length,Price,bar,reset); 
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1); 
//the determination of the error of the calculation of parameter JurX
//the second turning to function JurXSeries after number 1. ParameternJJurX.Length not menya.ttsya on each bar (nJurXdin=0)
  Error=JurXSeries(1,0,MaxBar,limit,JurX_Length,100,bar,reset); 
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1);
  if(Error==0)Error=1;
  JurX*=100/Error;
//turning to function JJMASeries after to numbers 0. ParametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
  JJurX=JJMASeries(0,0,MaxBar,limit,JJMA_Phase,JJMA_Length,JurX,bar,reset);
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1);
  Ind_Buffer[bar]=JJurX;                 
 }
//the completion of the calculations of the values of the indicator
return(0); 
} 
//+-------------------------------------------------------------------------+

