/*
Moving average LRMA, rasschitannnaya by the linear regression

For the work of indicator should be placed the files
JJMASeries.mqh 
LRMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                        JLRMA.mq4 |
//|                             LRMA CODE: Copyright ? 2006, alexjou |
//|                    Indicator: Copyright ? 2006, Nikolay Kositsin |
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the basic window
#property indicator_chart_window
//a quantity of the indicator buffers
#property indicator_buffers 1
//the color of the indicator
#property indicator_color1 MediumOrchid
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int MA_.Period = 8; //period LRMA
extern int Length = 3; //the depth of the smoothing
extern int Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of transient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double IndBuffer[];
//variables with the floating point
double JResalt, Price, Resalt;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+ 
//introduction to function LRMAMASeries
//introduction to function LRMASeriesResize
//introduction to function LRMASeriesAlert
//introduction to function LRMA_.ErrDescr
#include <LRMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| JLRMA initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
 {
//the installation of the size of the accuracy of mapping theindicator
  IndicatorDigits(Digits);
//the determination of the style of the performance of the graph
  SetIndexStyle(0, DRAW_LINE);
//1 indicator buffer is used for the calculation
  SetIndexBuffer(0, IndBuffer);
//the horizontal shift of the indicator line
  SetIndexShift (0, Shift); 
//the installation of the values of indicator, which not will be seenon the graph
  SetIndexEmptyValue(0, 0.0); 
//name for the windows of data and leyba for sub"okon
  IndicatorShortName ("JLRMA( Length="+Length+", Phase="+Phase+", Shift="+Shift+")");   
  SetIndexLabel(0, "JLRMA Line");
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
  SetIndexDrawBegin(0, MA_Period);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
  if (JJMASeriesResize(1)!=1)return(-1);
//a change in the sizes of the buffer variables of functionLRMASeries, nLRMAnumber=1(Odno turning to function LRMASeries)
  if (LRMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
  JJMASeriesAlert (0,"Length",Length);
  JJMASeriesAlert (1,"Phase", Phase );
  LRMASeriesAlert(0,"MA_Period",MA_Period);
  PriceSeriesAlert(Input_Price_Customs);
  return(0);
 }
//+------------------------------------------------------------------+ 
//| JLRMA iteration function                                         |
//+------------------------------------------------------------------+ 
int start()
 {
//checking a quantity of bars to the sufficiency for the calculation
if (Bars-1<MA_Period)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,MaxBarL,bar,Limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1;
MaxBarL=MaxBar-MA_Period;
Limit=Bars-counted_bars-1; 
//the calculation of the indicator
for (bar=Limit; bar>=0; bar--)
   { 
    //----+ 
     Price=PriceSeries(Input_Price_Customs,bar);
//obtaining the initial indicator
//turning to function LRMASeries after number 0
     Resalt=LRMASeries(0,MaxBar,Limit,MA_Period,Price,bar,reset); 
//checking to the absence of error in the previous operation
     if(reset!=0)return(-1);
//JMA the smoothing of the obtained indicator, parameter nJMA.MaxBaris reduced to MA_.Period
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
     JResalt=JJMASeries(0,0,MaxBarL,Limit,Phase,Length,Resalt,bar,reset);
//checking to the absence of error in the previous operation
     if(reset!=0)return(-1);
     IndBuffer[bar]=JResalt;
   }
 //----
  return(0);
 }
//+----------------------------------------------------+

