/*
For the work of indicator should be placed the files
JLiteSeries.mqh
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                        JLite.mq4 | 
//|                            Copyright ? 2006,    Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Red  
//THE INPUT PARAMETERS OF THE INDICATOR OF-----------------------------------------------------------------------------------------------------
extern int Length = 5; //the depth of the first smoothing
extern int Phase = 100; //the parameter of the first smoothing, whichis changed within limits of -100... 100, influence the quality oftransient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- ----------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double JLite[];
//variables with the floating point
double Temp_Series,Resalt;
//+------------------------------------------------------------------+  
//introduction to function JLiteSeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
#include <JLiteSeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| JLite indicator initialization function                          | 
//+------------------------------------------------------------------+  
int init() 
{  
//the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE); 
//1 indicator buffer is used for the calculation
SetIndexBuffer(0,JLite);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift); 
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);    
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("JLite( Length="+Length+", Phase="+Phase+",  Shift="+Shift+")"); 
SetIndexLabel (0, "JLite"); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Length",Length);
JJMASeriesAlert (1,"Phase", Phase);
PriceSeriesAlert(Input_Price_Customs);
//a change in the sizes of the buffer variables of functionJLiteSeries, nJMAnumber=1(Odno turning to function JLiteSeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| JLite iteration function                                         | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<31)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1; int limit=MaxBar-counted_bars;

//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(int bar=limit;bar>=0;bar--)
  {
//turning to function PriceSeries for obtaining the input priceSeries
    Temp_Series=PriceSeries(Input_Price_Customs, bar);
//turning to function JLiteSeries after to numbers 0. ParametersnJLitePhase and nJLiteLength do not change on each bar (nJLitedin=0)
    Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,Temp_Series,bar,reset);
//checking to the absence of error in the previous operation
    if(reset!=0)return(-1);
    JLite[bar]=Resalt;
  }
//the completion of the calculations of the values of the indicator
return(0); 
} 

//+-----------------------------------------------------------+

