/*
*** Morris MA *** 
Version 2 (29th May 2004) 
** forex version **
use short duration bars e.g. 
5min set length to give required speed of response
increase damping to eliminate overshooting 
Lower length will require Higher damping
*/
/*
For the work of indicator should be placed the files
INDICATOR_COUNTED.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                   JMorris MA.mq4 |
//|                Copyright ? 2003,2004                  Tim Morris |
//|                     MQL4 ? 2005,                Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1
#property indicator_color1 Red
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int       Length  = 10;//inverse of driving coefficient
extern int      damping  = 5;//smoothing (percent)
extern int       maxgap  = 30;//maximum week gap ignored (pips)
extern int Smooth = 8; //the depth of the smoothing
extern int Smooth_.Phase = y00;///the parameter of smoothing, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int        Shift  = 0;
extern int Input_.Price_.Customs = 2; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double MMA_Buffer [];
double MEMORY[];
//variables with the floating point
double p, dmp, drv, gap;
double n, k, d0, y0, y1, y2, mg, err, Resalt; 
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| Morris MA initialization function                                | 
//+------------------------------------------------------------------+  
int init()
  {  
//the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE); 
//2 indicator buffers are used for the calculation
IndicatorBuffers(2);  
SetIndexBuffer(0, MMA_Buffer);
SetIndexBuffer(1, MEMORY);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift);  
//name for the windows of data and leyba for sub"okon
SetIndexLabel   (0, "Moris_MA");
IndicatorShortName ("Moris_MA (Length="+Length+", damping="+damping+", maxgap="+maxgap+", Shift="+Shift+")");    
//the initialization of the constants
   k =1.0/Length; d0 = damping/100.0; mg = maxgap*Point;  
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Length",Length);
JJMASeriesAlert (0,"Smooth",Smooth);
JJMASeriesAlert (1,"Smooth_Phase", Smooth_Phase);
PriceSeriesAlert(Input_Price_Customs);
//korektsiya of the inadmissible value of parameter Bands_.Period
if(Length<1)Length=1; 
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+  
//| Morris MA iteration function                                     | 
//+------------------------------------------------------------------+  
int start()
  {
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<Length+31)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int MaxBar,reset,bar,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1;MaxBar=Bars-1-2;

if (limit>=MaxBar)
	{
   	limit=MaxBar;
   	y0=PriceSeries(Input_Price_Customs,MaxBar);
   	//----
   	MEMORY[MaxBar+0]=y0;
      MEMORY[MaxBar+1]=y0;
      MEMORY[MaxBar+2]=y0; 
      //----
	   MMA_Buffer[MaxBar+0]=y0;
	   MMA_Buffer[MaxBar+1]=0.0;
   	MMA_Buffer[MaxBar+2]=0.0;  
   }
bar=limit;
while (bar>=0)
	{
	  p=PriceSeries(Input_Price_Customs,bar);
//week} gap compensation------------------------------------------+
	  if (Time[bar]-Time[bar+1]>30000)
		 if ((High[bar]<Low[bar+1])||(Low[bar]>High[bar+1]))
			{
	    		gap=p-PriceSeries(Input_Price_Customs,bar+1);
	    		if (MathAbs(gap)>mg){MEMORY[bar+1]+=gap; MEMORY[bar+2]+=gap;}
	    	}
//----------------------------------------------------------------+	
//*** calculate new average position ***
   y1  = MEMORY[bar+1]; 
   y2  = MEMORY[bar+2];
   n   = High[bar]-Low[bar];//consider H-L as noise level
   if(n==0)n=Point/100;
   err = (p-2.0*y1+y2)/n; 
//error is difference between price && straight line
   drv = MathMax(MathMin(k*err*err + k*MathAbs(err),0.5),0.0);
//driving function = polynomial of error/noise
//small moves have little effect, 
//big moves have big effect, 
//spikes have small effect
	dmp = MathMax(MathMin(k*MathAbs(y1-y2)/n + d0,1.0),0.0);
//damping function = polynomial of gradient/noise
//if average is moving fast but price isn't - put the brakes on.
   y0  = y1 + n*err*drv + (y1-y2)*(1.0-dmp);
//new average = straight line less damping plus driving
   MEMORY[bar+0]=y0; 
//turning to function JJMASeries after to numbers 0. ParametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
   Resalt=JJMASeries(0,0,MaxBar,limit,Smooth_Phase,Smooth,y0,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   MMA_Buffer[bar]=Resalt;
	bar--;
	}
//---- done---
return(0); 
}
//+---------------------------------------------------+

