/*
For the work of indicator should be placed the files

JurXSeries.mqh, 
PriceSeries.mqh,  
in the folder (directory): MetaTrader\.experts\.include \

Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \

At the basis of this indicator the algorithm of smoothing from theindicator lies
JRSX. The eventual result of this algorithm has a certain similaritys
by dual JMA smoothing, but in view of larger simplicity is lessperfect.
*/
//+------------------------------------------------------------------+  
//|                                                         JurX.mq4 | 
//|          JurXSeries MQL4: Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Yellow
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Length = 5; //the depth of the first smoothing
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer[];
//variables with the floating point
double Price,JurX,Error;
//+------------------------------------------------------------------+   
//introduction to function JurXSeries
//introduction to function JurXSeriesResize
//introduction to function JurXSeriesAlert
//introduction to function JurX_.ErrDescr
#include <JurXSeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| JurX indicator initialization function                           | 
//+------------------------------------------------------------------+  
int init() 
{  
//the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE); 
//1 indicator buffer is used for the calculation
SetIndexBuffer(0,Ind_Buffer);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift); 
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0); 
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("JurX( Length="+Length+", Shift="+Shift+")"); 
SetIndexLabel (0, "JurX"); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//introduction and the initialization of the internal variablefunctions JurXSeries, nJurXnumber=2(Dva turning to function)
if (JurXSeriesResize(2)!=2)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JurXSeriesAlert  (0,"Length",Length  ); 
PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| JurX iteration function                                          | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<Length+1)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted (without this conversionfor counted_.bars function JurXSeries it will work incorrectly!!!)
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1; MaxBar=Bars-1; 

//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(int bar=limit;bar>=0;bar--)
 {
//turning to function PriceSeries for obtaining the input priceSeries
  Price=PriceSeries(Input_Price_Customs,bar);
//one turning to function JurXSeries after number 0. ParameternJJurXLength not menya.ttsya on each bar (nJurXdin=0)
  JurX=JurXSeries(0,0,MaxBar,limit,Length,Price,bar,reset); 
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1);  
//the determination of the error of the calculation of parameter JurX
//the second turning to function JurXSeries after number 1. ParameternJJurXLength not menya.ttsya on each bar (nJurXdin=0)
  Error=JurXSeries(1,0,MaxBar,limit,Length,100,bar,reset); 
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1); 
  if(Error==0)Error=1;
  Ind_Buffer[bar]=JurX*100/Error;                 
 }
//the completion of the calculations of the values of the indicator
return(0); 
} 
//+-----------------------------------------------------------------+

