/*
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                     3c_JMACD.mq4 | 
//|                 3c_JMACD: Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 5
//the color of the indicator
#property indicator_color1  BlueViolet 
#property indicator_color2  Blue
#property indicator_color3  Magenta
#property indicator_color4  Gray
#property indicator_color5  Red
//the thickness of the indicator lines
#property indicator_width1 0
#property indicator_width2 3 
#property indicator_width3 3
#property indicator_width4 4
//the style of the envelope of the indicator
#property indicator_style1 4
//the style of the signal line of the indicator
#property indicator_style5 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1 0.0
#property indicator_levelcolor Red 
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int FastJMA=12; //the depth of the smoothing of rapid JMA
extern int SlowJMA=26; //the depth of the smoothing of slow JMA
extern int SignalJMA=9; //the depth of the smoothing of signal JMA
extern int JMAccD_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khof processes JMACD
extern int Signal_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khof the processes of the signal line
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_buffer1[];
double Ind_buffer2[];
double Ind_buffer3[];
double Ind_buffer4[];
double Ind_buffer5[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JMACD initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(4,DRAW_LINE);
//4 indicator buffers are used for the calculation
if(!SetIndexBuffer(0,Ind_buffer1)&& 
   !SetIndexBuffer(1,Ind_buffer2)&& 
   !SetIndexBuffer(2,Ind_buffer3)&& 
   !SetIndexBuffer(3,Ind_buffer4)&& 
   !SetIndexBuffer(4,Ind_buffer5))
Print("Nevozmojno to establish indicator buffers!");
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0.0);  
   SetIndexEmptyValue(1,0.0); 
   SetIndexEmptyValue(2,0.0); 
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);  
//names for the windows of data and leyby for sub"okon
   IndicatorShortName("JMACD("+FastJMA+","+SlowJMA+","+SignalJMA+")");
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,"Up_Trend");
   SetIndexLabel(2,"Down_Trend");
   SetIndexLabel(3,"Straight_Trend");
   SetIndexLabel(4,"Signal");
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=2(Dva turning to function JJMASeries)
   if (JJMASeriesResize(3)!=3)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"FastJMA",FastJMA);
   JJMASeriesAlert (0,"SlowJMA",SlowJMA);
   JJMASeriesAlert (0,"SignalJMA",SignalJMA);
   JJMASeriesAlert (1,"JMACD_Phase", JMACD_Phase);
   JJMASeriesAlert (1,"Signal_Phase", Signal_Phase);
   PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//| JMACD iteration function                                         |
//+------------------------------------------------------------------+ 
int start()
  {
//the introduction of variables with the floating point
   double F.JMA,S.JMA,JMACD,Series,trend,Signal;
//the introduction of entire variables and obtaining the alreadycalculated bars
   int reset,limit,MaxBar,MaxBarS,counted_bars=IndicatorCounted();
//checking to the possible errors
   if (counted_bars<0)return(-1);
//the last calculated bar must be converted
   if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
   limit=Bars-counted_bars-1; MaxBar=Bars-1; MaxBarS=MaxBar-30;
   
//THE BASIC CYCLE OF THE CALCULATION OF INDICATOR JMACD
   for(int bar=limit; bar>=0; bar--)
    {
//turning to function PriceSeries for obtaining the input priceSeries
     Series=PriceSeries(Input_Price_Customs, bar);  
       
//two turnings to function JJMASeries after numbers 0, 1. ParametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
     F.JMA=JJMASeries(0,0,MaxBar,limit,JMACD_Phase,FastJMA,Series,bar,reset);
//checking to the absence of error in the previous operation
     if(reset!=0)return(-1);
     //+---------------------------------------------------------------------+
     S.JMA=JJMASeries(1,0,MaxBar,limit,JMACD_Phase,SlowJMA,Series,bar,reset);
//checking to the absence of error in the previous operation
     if(reset!=0)return(-1); 
     //+---------------------------------------------------------------------+
//formula for JMACD
     JMACD=F.JMA-S.JMA;
//a change in the unit of measurement JMACD to the points
     JMACD = JMACD/Point;
     Ind_buffer1[bar]=JMACD;
     
//SSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
     trend=JMACD-Ind_buffer1[bar+1];     
     if(trend>0.0)     {Ind_buffer2[bar]=JMACD;  Ind_buffer3[bar]=0.0;    Ind_buffer4[bar]=0.0;}
     else{if(trend<0.0){Ind_buffer2[bar]=0.0;    Ind_buffer3[bar]=JMACD;  Ind_buffer4[bar]=0.0;}
     else              {Ind_buffer2[bar]=0.0;    Ind_buffer3[bar]=0.0;    Ind_buffer4[bar]=JMACD;}}    
     //---- +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
     
//turning to function JJMASeries after number 2, (nJMA.din=0, in thisrotation parameter nJMA.MaxBar it is reduced by 30 since this repeatedJMA smoothing)
     Signal=JJMASeries(2,0,MaxBarS,limit,Signal_Phase,SignalJMA,JMACD,bar,reset);
//checking to the absence of error in the previous operation
     if(reset!=0)return(-1);
     Ind_buffer5[bar]=Signal;
   }
   if(limit>=MaxBar-31){int iii=MaxBar-31;Ind_buffer2[iii]=0;Ind_buffer3[iii]=0;Ind_buffer4[iii]=0;} 
//the completion of the calculations of the values of the indicator
   return(0);
  } 
//+-------------------------------------------------------------------------------+

