/*
For the work of indicator should be placed the files

JJMASeries.mqh 
and PriceSeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
JFatl.mq4
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                    3c_JMACDf.mq4 | 
//|                   JMACDf: Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 4
//the color of the indicator
#property indicator_color1  Yellow 
#property indicator_color2  Red
#property indicator_color3  Gray
#property indicator_color4  Blue
//the thickness of the indicator lines
#property indicator_width1 3
#property indicator_width2 3 
#property indicator_width3 3
//the style of the signal line of the indicator
#property indicator_style4 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1 0.0
#property indicator_levelcolor LimeGreen  
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int FastJFatl=8; //the depth of the smoothing of rapid jFatl
extern int SlowJFatl=20; //the depth of the smoothing of slow jFatl
extern int SignalJMA=12; //the depth of the smoothing of signal JMA
extern int JMAccD_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khof processes JMACD
extern int Signal_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khof the processes of the signal line
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_buffer1[];
double Ind_buffer2[];
double Ind_buffer3[];
double Ind_buffer4[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JMACDf initialization function                                   |
//+------------------------------------------------------------------+ 
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(3,DRAW_LINE);
//4 indicator buffers are used for the calculation
if(!SetIndexBuffer(0,Ind_buffer1)&& 
   !SetIndexBuffer(1,Ind_buffer2)&& 
   !SetIndexBuffer(2,Ind_buffer3)&& 
   !SetIndexBuffer(3,Ind_buffer4))
Print("Nevozmojno to establish indicator buffers!");
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0.0);  
   SetIndexEmptyValue(1,0.0); 
   SetIndexEmptyValue(2,0.0); 
   SetIndexEmptyValue(3,0.0);  
//names for the windows of data and leyby for sub"okon
   IndicatorShortName("JMACDf("+FastJFatl+","+SlowJFatl+","+SignalJMA+")");
   SetIndexLabel(0,"Up_Trend");
   SetIndexLabel(1,"Down_Trend");
   SetIndexLabel(2,"Straight_Trend");
   SetIndexLabel(3,"Signal");
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
   if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"FastJFatl",FastJFatl);
   JJMASeriesAlert (0,"SlowJFatl",SlowJFatl);
   JJMASeriesAlert (0,"SignalJMA",SignalJMA);
   JJMASeriesAlert (1,"JMACD_Phase", JMACD_Phase);
   JJMASeriesAlert (1,"Signal_Phase", Signal_Phase);
   PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//| JMACDf iteration function                                        |
//+------------------------------------------------------------------+ 
int start()
  {
//the introduction of variables with the floating point
   double Fast.JFATL,Slow.JFATL,JMACDf,Series,trend,Signal;
//the introduction of entire variables and obtaining the alreadycalculated bars
   int reset,limit,MaxBar,MaxBarS,counted_bars=IndicatorCounted();
//checking to the possible errors
   if (counted_bars<0)return(-1);
//the last calculated bar must be converted
   if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
   limit=Bars-counted_bars-1; MaxBar=Bars-1; MaxBarS=MaxBar-30;
   
//THE BASIC CYCLE OF THE CALCULATION OF INDICATOR JMACD
   for(int bar=limit; bar>=0; bar--)
    {
//turning to function PriceSeries for obtaining the input priceSeries
     Series=PriceSeries(Input_Price_Customs, bar);        
//two turnings to the user indicator JFatl
     Fast.JFATL= iCustom(NULL,0,"JFatl",FastJFatl,JMACD_Phase,0,Input_Price_Customs,0,bar);
     Slow.JFATL= iCustom(NULL,0,"JFatl",SlowJFatl,JMACD_Phase,0,Input_Price_Customs,0,bar);     
//formula for JMAccDf
     JMACDf=Fast.JFATL-Slow.JFATL;
//a change in the unit of measurement JMAccDf to the points
     JMACDf = JMACDf/Point;    
//SSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
     trend=JMACDf-Ind_buffer1[bar+1]-Ind_buffer2[bar+1]-Ind_buffer3[bar+1];     
     if(trend>0.0)     {Ind_buffer1[bar]=JMACDf;  Ind_buffer2[bar]=0.0;     Ind_buffer3[bar]=0.0;}
     else{if(trend<0.0){Ind_buffer1[bar]=0.0;     Ind_buffer2[bar]=JMACDf;  Ind_buffer3[bar]=0.0;}
     else              {Ind_buffer1[bar]=0.0;     Ind_buffer2[bar]=0.0;     Ind_buffer3[bar]=JMACDf;}}    
/SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSY.SSSSSSSSSSSSSSSSS
     
//turning to function JJMASeries after number 0, (nJMA.din=0, in thisrotation parameter nJMA.MaxBar
//is reduced by 30 since this repeated JMA smoothing: previous was inindicator JFatl)
     Signal=JJMASeries(0,0,MaxBarS,limit,Signal_Phase,SignalJMA,JMACDf,bar,reset);
//checking to the absence of error in the previous operation
     if(reset!=0)return(-1);
     Ind_buffer4[bar]=Signal;
     //----+
   }
   if(limit>=MaxBarS){int iii=MaxBarS;Ind_buffer1[iii]=0;Ind_buffer2[iii]=0;Ind_buffer3[iii]=0;} 
//the completion of the calculations of the values of the indicator
   return(0);
  } 
//+-----------------------------------------------------------------------+

