/*
// Created by Starlight (extesy@y&&ex.ru). Don't remove this line even if you do conversion to EL,MQL etc!
/---- 
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                     3c_JVEL1.mq4 |
//|   MQL4+3color: Copyright ? 2006,                Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers  4
//the color of the indicator
#property indicator_color1  LimeGreen
#property indicator_color2  Magenta
#property indicator_color3  Gray
#property indicator_color4  Yellow
//the thickness of the indicator lines
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
//the style of the signal line of the indicator
#property indicator_style4 4
//the parameters of the horizontal levels of the indicator
#property indicator_level3  0.0
#property indicator_levelcolor MediumBlue
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Depth=10; //the depth of the smoothing of the indicator
extern int Sign.Length=12; //the depth of the smoothing of the signalline
extern int Sign.Phase = 100; //the parameter of signal line, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int Input_.Price_.Customs = ya;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[];
double Ind_Buffer4[];
//variables with the floating point
double jrc01,jrc04,jrc05,jrc06,jrc07,jrc08,jrc09,trend,JVEL1,Signal;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JVEL1 initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(3,DRAW_LINE);
//4 indicator buffers are used for the calculation
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexBuffer(2,Ind_Buffer3);
   SetIndexBuffer(3,Ind_Buffer4);
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0); 
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
   SetIndexEmptyValue(3,0);
//names for the windows of data and leyby for sub"okon
   SetIndexLabel(0,"Up_Trend"  );  
   SetIndexLabel(1,"Down_Trend"); 
   SetIndexLabel(2,"Straight_Trend"); 
   SetIndexLabel(3,"Signal"  );    
   IndicatorShortName("JVELaux1( Depth="+Depth+"Input_Price_Customs="+Input_Price_Customs+")"); 
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
   if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"Depth",Depth);
   JJMASeriesAlert (0,"Sign.Length",Sign.Length);
   JJMASeriesAlert (1,"Sign.Phase", Sign.Phase);
   PriceSeriesAlert(Input_Price_Customs);
//korektsiya of the inadmissible value of parameter Depth
   if(Depth<1)Depth=1; 
//the initialization of the coefficients
   jrc04 = Depth + 1.0;
   jrc05 = jrc04 * (jrc04+1.0)/2.0;
   jrc06 = jrc05 * (2*jrc04+1.0)/3.0;
   jrc07 = jrc05 * jrc05 * jrc05 - jrc06 * jrc06; 
//the completion of the initialization
return(0);
  }
//+------------------------------------------------------------------+ 
//| JVEL1 CODE                                                       |
//+------------------------------------------------------------------+ 
int start()
{
//checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=Depth)return(0);  
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,limit,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1-Depth;
//korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
//initialization of zero
if (limit>MaxBar)
 {
  limit=MaxBar; 
  for(int ttt=Bars-1;ttt>MaxBar;ttt--)
   {
    Ind_Buffer1[ttt]=0.0; 
    Ind_Buffer2[ttt]=0.0; 
   }
 }

//the calculation of the indicator
for(int bar=limit; bar>=0; bar--)
  {
    jrc08 = 0.0;
    jrc09 = 0.0;
    for(int jj=0; jj<=Depth; jj++)
    {
//turning to function PriceSeries for obtaining the input price jrc01
      jrc01=PriceSeries(Input_Price_Customs, bar+jj);    
      //----+ 
      jrc08 = jrc08 + jrc01 * (jrc04 - jj);
      jrc09 = jrc09 + jrc01 * (jrc04 - jj) * (jrc04 - jj);
    }
     JVEL1 = (jrc09*jrc05 - jrc08*jrc06) / jrc07; 
     JVEL1 = JVEL1/Point;
//SSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
     trend=JVEL1-Ind_Buffer1[bar+1]-Ind_Buffer2[bar+1]-Ind_Buffer3[bar+1];     
     if(trend>0)     {Ind_Buffer1[bar]=JVEL1;  Ind_Buffer2[bar]=0;      Ind_Buffer3[bar]=0;}
     else{if(trend<0){Ind_Buffer1[bar]=0;      Ind_Buffer2[bar]=JVEL1;  Ind_Buffer3[bar]=0;}
     else            {Ind_Buffer1[bar]=0;      Ind_Buffer2[bar]=0;      Ind_Buffer3[bar]=JVEL1;}}    
     //---- +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+

//the calculation of signal line (turning to function JJMASeries afternumber 0, parameters nJMA.Phase and nJMA.Length they do not change oneach bar (nJMA.din=0))
    Signal=JJMASeries(0,0,MaxBar,limit,100,Sign.Length,JVEL1,bar,reset);
//checking to the absence of error in the previous operation
    if(reset!=0)return(-1);
    Ind_Buffer4[bar]=Signal; 
  } 
return(0);
//the completion of the calculations of the values of the indicator
}

//+--------------------------------------------------------------------+

