/*
For the work of indicator should be placed the files
JJMASeries.mqh
JurSeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                        JCCIX.mq4 |
//|                              Copyright ? 2006,  Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers  1
//the color of the indicator
#property indicator_color1  BlueViolet
//the parameters of the horizontal levels of the indicator
#property indicator_level1  0.5
#property indicator_level2 -0.5
#property indicator_level3  0.0
#property indicator_levelcolor MediumBlue
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int JJMA.Length = 8; //depth JJMA of the smoothing of the inputprice
extern int JurX.Length = 8; //depth JurX of the smoothing of theobtained indicator
extern int JJMA.Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of perekhodny.kh of theprocesses of the smoothing
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer1[];
//the entire constants
int    w;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+ 
//introduction to function JurXSeries
//introduction to function JurXSeriesResize
//introduction to function JurXSeriesAlert
//introduction to function JurX_.ErrDescr
#include <JurXSeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JCCIX initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
 {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
//1 indicator buffer is used for the calculation.
   SetIndexBuffer(0,Ind_Buffer1);
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0); 
//names for the windows of data and leyby for sub"okon
   SetIndexLabel(0,"JCCIX");
   IndicatorShortName("JCCIX(JJMA.Length="+JJMA.Length+", JurX.Length"+JurX.Length+")");
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(2);
//a change in the sizes of the buffer variables of functionJurXSeries, nJurXnumber=2(Dva turning to function JurXSeries)
   if (JurXSeriesResize(2)!=2)return(-1);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
   if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
   JurXSeriesAlert (0,"JurX.Length",JurX.Length);
   JJMASeriesAlert (0,"JJMA.Length",JJMA.Length);
   JJMASeriesAlert (1,"JJMA.Phase",JJMA.Phase);
   PriceSeriesAlert(Input_Price_Customs);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,JurX.Length+31);
//the initialization of coefficients for calculating the indicator
   if (JurX.Length>5) w=JurX.Length-1; else w=5;
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//|  JCommodity Channel IndexX                                       |
//+------------------------------------------------------------------+ 
int start()
  {
//the introduction of variables with the floating point
double price,Jprice,JCCIX,UPCCI,DNCCI,JUPCCIX,JDNCCIX; 
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,MaxBarJ,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
//(without this conversion for counted_.bars of function JJMASeriesand JurXSeries they will work incorrectly!!!)
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1; MaxBarJ=MaxBar-30;
//korektsiya of the starting raschetogo bar in the cycle
if(limit>=MaxBar)limit=MaxBar;

for(int bar=limit; bar>=0; bar--)
 { 
//turning to function PriceSeries for obtaining the input priceSeries
   price=PriceSeries(Input_Price_Customs, bar);
   //+----------------------------------------------------------------------------+ 
//one turning to function JJMASeries after to numbers 0.
//parameters nJMA.Phase and nJMA.Length do not change on each bar(nJMA.din=0)
   //+----------------------------------------------------------------------------+   
   Jprice=JJMASeries(0,0,MaxBar,limit,JJMA.Phase,JJMA.Length,price,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   //+----------------------------------------------------------------------------+    
   UPCCI=price-Jprice;         
   DNCCI=MathAbs(UPCCI);
//two turnings to function JurXSeries after numbers 0 and 1. ParameternJJurXLength not menya.ttsya on each bar (nJurXdin=0)
//checking to the absence of error in the previous operation
   JUPCCIX=JurXSeries(0,0,MaxBarJ,limit,JurX.Length,UPCCI,bar,reset); if(reset!=0)return(-1); 
   JDNCCIX=JurXSeries(1,0,MaxBarJ,limit,JurX.Length,DNCCI,bar,reset); if(reset!=0)return(-1); 
   //----+
   if (bar>MaxBarJ-w)JCCIX=0;
   else 
     if (JDNCCIX!=0)
       {
        JCCIX=JUPCCIX/JDNCCIX;
        if(JCCIX>1)JCCIX=1;
        if(JCCIX<-1)JCCIX=-1;
       }
     else JCCIX=0;
   Ind_Buffer1[bar]=JCCIX; 
   //----+
 }
//----
   return(0);
  }
//+---------------------------------------------------------------------------+


