/*
For the work of indicator should be placed the files

JJMASeries.mqh 
and PriceSeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
JFatl.mq4
in the folder (directory): MetaTrader\.experts\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                       JMACDf.mq4 | 
//|                   JMACDf: Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 2
//the color of the indicator
#property indicator_color1  Gray
#property indicator_color2  Red
//the thickness of the indicator lines
#property indicator_width1 3
//the style of the signal line of the indicator
#property indicator_style2 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1 0.0
#property indicator_levelcolor Blue 
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int FastJFatl=12; //the depth of the smoothing of rapid jFatl
extern int SlowJFatl=26; //the depth of the smoothing of slow jFatl
extern int SignalJMA=9; //the depth of the smoothing of signal JMA
extern int JMAccD_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khof processes JMACD
extern int Signal_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khof the processes of the signal line
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_buffer1[];
double Ind_buffer2[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JMACDf initialization function                                   |
//+------------------------------------------------------------------+ 
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(1,DRAW_LINE);
//2 indicator buffers are used for the calculation
if(!SetIndexBuffer(0,Ind_buffer1)&& 
   !SetIndexBuffer(1,Ind_buffer2))
   Print("cannot set indicator buffers!");
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0.0);  
   SetIndexEmptyValue(1,0.0); 
//names for the windows of data and leyby for sub"okon
   IndicatorShortName("JMACDf("+FastJFatl+","+SlowJFatl+","+SignalJMA+")");
   SetIndexLabel(0,"JMACDf");
   SetIndexLabel(1,"Signal");
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
   if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"FastJFatl",FastJFatl);
   JJMASeriesAlert (0,"SlowJFatl",SlowJFatl);
   JJMASeriesAlert (0,"SignalJMA",SignalJMA);
   JJMASeriesAlert (1,"JMACD_Phase", JMACD_Phase);
   JJMASeriesAlert (1,"Signal_Phase", Signal_Phase);
   PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//| JMACDf iteration function                                        |
//+------------------------------------------------------------------+ 
int start()
  {
//the introduction of variables with the floating point
   double Fast.JFATL,Slow.JFATL,JMACDf,Series,Signal;
//the introduction of entire variables and obtaining the alreadycalculated bars
   int reset,limit,MaxBar,MaxBarS,counted_bars=IndicatorCounted();
//checking to the possible errors
   if (counted_bars<0)return(-1);
//the last calculated bar must be converted
   if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
   MaxBar=Bars-1; MaxBarS=MaxBar-30;limit=MaxBar-counted_bars; 
   
//THE BASIC CYCLE OF THE CALCULATION OF INDICATOR JMACD
   for(int bar=limit; bar>=0; bar--)
    {
//turning to function PriceSeries for obtaining the input priceSeries
     Series=PriceSeries(Input_Price_Customs, bar);    
//two turnings to the user indicator JFatl
     Fast.JFATL= iCustom(NULL,0,"JFatl",FastJFatl,JMACD_Phase,0,Input_Price_Customs,0,bar);
     Slow.JFATL= iCustom(NULL,0,"JFatl",SlowJFatl,JMACD_Phase,0,Input_Price_Customs,0,bar);     
//formula for JMAccDf
     JMACDf=Fast.JFATL-Slow.JFATL;
//a change in the unit of measurement JMAccDf to the points
     JMACDf = JMACDf/Point;
     Ind_buffer1[bar]=JMACDf;     
//turning to function JJMASeries after number 0, (nJMA.din=0)
     Signal=JJMASeries(0,0,MaxBarS,limit,Signal_Phase,SignalJMA,JMACDf,bar,reset);
//checking to the absence of error in the previous operation
     if(reset!=0)return(-1);
     Ind_buffer2[bar]=Signal;
     //----+
    } 
//the completion of the calculations of the values of the indicator
   return(0);
  } 

//+----------------------------------------------------------------------+


