/*
For the work of indicator should be placed the files
JMASeries.mqh,
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \

Indicator Momentum (rate) measures the value of a price change ofpaper after
the specific period. Basic methods of using the indicator of the rate:
As the oscillator, which follows after the tendency, is analogousMACD. In
this case signal to the purchase appears, if indicator is formed
cavity begins grow; and signal to sale - when it reaches the peak
and it turns downward. For the more precision determination of themoments of the turn
indicator it is possible to use its short moving average. Extremely
the high or low values of the indicator of rate assume thecontinuation
the current tendency. Thus, if indicator reaches the extremely high
values and then it turns downward, it follows to expect furtherincrease
prices. But in any event with the discovery (or closing) of positionit is not necessary
to hurry until price they confirm the signal of indicator. In
the quality of the anticipating indicator. This method is based on theassumption
about the fact that the final phase of the ascending tendency usually
is accompanied by a swift increase in the prices (since everythingthey believe in it
continuation), and the end of bear market - by their sharp drop (thus
as all attempt to leave the market). Specifically, so frequently andit occurs, but
nevertheless this too wide a generalization.
In this indicator classical Momentum is smoothed with the aid of thealgorithm
JMA. 
*/
//+------------------------------------------------------------------+  
//|                                                    JMomentum.mq4 | 
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Lime
//the parameters of the horizontal levels of the indicator
#property indicator_level1 0.0
#property indicator_levelcolor Blue
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Mom_.Period = 8; //period Momentum
extern int Smooth = 8; //depth JMA of the smoothing of the finishedindicator
extern int Smooth_.Phase = y00;///the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khJMA of the processes of the smoothing
extern int Ind_.Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer1[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+   
//| JMomentum initialization function                                | 
//+------------------------------------------------------------------+  
int init() 
{ 
//1 indicator buffer is used for the calculation.
SetIndexBuffer(0,Ind_Buffer1);
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0); 
//the horizontal shift of the indicator lines
SetIndexShift (0, Ind_Shift); 
//the style of the performance of graph the form of the point line
SetIndexStyle(0,DRAW_LINE);
//names for the windows of data and leyby for sub"okon
SetIndexLabel   (0, "JMomentum"); 
IndicatorShortName ("JMomentum"); 
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(0);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Mom_Period",Mom_Period);
JJMASeriesAlert (0,"Smooth",Smooth);
JJMASeriesAlert (1,"Smooth_Phase", Smooth_Phase);
PriceSeriesAlert(Input_Price_Customs);
//korektsiya of the inadmissible value of parameter Mom_.Period
if(Mom_Period<1)Mom_Period=1; 
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
int draw_begin=Mom_Period+30; 
SetIndexDrawBegin(0,draw_begin); 
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| JMomentum iteration function                                     | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<Mom_Period+31)return(0);
//the introduction of variables with the floating point
double Momentum,JMomentum;
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,bar,MaxBarM,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBarM=Bars-1-Mom_Period;
//initialization by zero nepodschityvayemykh buffer values and thecorrection of the number of the oldest bar, beginning from which therewill be proizeden the conversion of the new bars
if (limit>=MaxBarM)
   {
    for(bar=limit;bar>=MaxBarM;bar--)Ind_Buffer1[bar]=0.0;
    limit=MaxBarM;
   }  
       
//THE BASIC CYCLE OF THE CALCULATION OF INDICATOR JMOMENTUM
for(bar=limit;bar>=0;bar--)
   {
//the calculation formula of indicator Mom_.Period (two turnings tofunction PriceSeries)
    Momentum=PriceSeries(Input_Price_Customs,bar)-PriceSeries(Input_Price_Customs,bar+Mom_Period);  
//a change in the unit of measurement JMomentum to the points
    double point = Point;
    if (point==0)return(-1);
    Momentum=Momentum/point;
//the smoothing of indicator Momentum
//the turning to function JJMASeries after number 0, parametersnJMASmooth_.Phase and nJMASmooth do not change on each bar(nJMA.din=0)
    JMomentum=JJMASeries(0,0,MaxBarM,limit,Smooth_Phase,Smooth,Momentum,bar,reset);
//checking to the absence of error in the previous operation
    if(reset!=0)return(-1);    
    Ind_Buffer1[bar]=JMomentum;
   }
//the completion of the calculations of the values of the indicator
return(0);  
}
//+------------------------------------------------------------------------------+


